--------------------------------------------------------------------------------
-- Copyright (c) 1995-2005 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version: H.42
--  \   \         Application: netgen
--  /   /         Filename: adder_synthesis.vhd
-- /___/   /\     Timestamp: Tue Jul 04 18:59:35 2006
-- \   \  /  \ 
--  \___\/\___\
--             
-- Command	: -intstyle ise -ar Structure -w -ofmt vhdl -sim adder.ngc adder_synthesis.vhd 
-- Device	: xc2vp50-7-ff1152
-- Input file	: adder.ngc
-- Output file	: adder_synthesis.vhd
-- # of Entities	: 1
-- Design Name	: adder
-- Xilinx	: C:/Xilinx
--             
-- Purpose:    
--     This VHDL netlist is a verification model and uses simulation 
--     primitives which may not represent the true implementation of the 
--     device, however the netlist is functionally correct and should not 
--     be modified. This file cannot be synthesized and should only be used 
--     with supported simulation tools.
--             
-- Reference:  
--     Development System Reference Guide, Chapter 23
--     Synthesis and Verification Design Guide, Chapter 6
--             
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

entity adder is
  port (
    in_reset_n : in STD_LOGIC := 'X'; 
    in_user_clk : in STD_LOGIC := 'X'; 
    in_data_00 : in STD_LOGIC_VECTOR ( 15 downto 0 ); 
    in_data_01 : in STD_LOGIC_VECTOR ( 15 downto 0 ); 
    in_data_02 : in STD_LOGIC_VECTOR ( 15 downto 0 ); 
    in_data_03 : in STD_LOGIC_VECTOR ( 15 downto 0 ); 
    in_data_04 : in STD_LOGIC_VECTOR ( 15 downto 0 ); 
    in_data_05 : in STD_LOGIC_VECTOR ( 15 downto 0 ); 
    in_data_06 : in STD_LOGIC_VECTOR ( 15 downto 0 ); 
    in_data_07 : in STD_LOGIC_VECTOR ( 15 downto 0 ); 
    out_data : out STD_LOGIC_VECTOR ( 21 downto 0 ) 
  );
end adder;

architecture Structure of adder is
  signal adder_n0001_5_cyo : STD_LOGIC; 
  signal adder_n0002_7_cyo : STD_LOGIC; 
  signal adder_n0005_15_cyo : STD_LOGIC; 
  signal adder_n0002_5_cyo : STD_LOGIC; 
  signal N126 : STD_LOGIC; 
  signal N124 : STD_LOGIC; 
  signal adder_n0000_8_cyo : STD_LOGIC; 
  signal N123 : STD_LOGIC; 
  signal adder_n0001_0_cyo : STD_LOGIC; 
  signal adder_n0001_1_cyo : STD_LOGIC; 
  signal adder_n0003_15_cyo : STD_LOGIC; 
  signal N104 : STD_LOGIC; 
  signal adder_n0002_3_cyo : STD_LOGIC; 
  signal N98 : STD_LOGIC; 
  signal adder_n0000_12_cyo : STD_LOGIC; 
  signal N97 : STD_LOGIC; 
  signal N93 : STD_LOGIC; 
  signal N99 : STD_LOGIC; 
  signal adder_n0001_10_cyo : STD_LOGIC; 
  signal adder_n0001_15_cyo : STD_LOGIC; 
  signal N127 : STD_LOGIC; 
  signal adder_n0001_4_cyo : STD_LOGIC; 
  signal N94 : STD_LOGIC; 
  signal adder_n0003_13_cyo : STD_LOGIC; 
  signal adder_n0001_9_cyo : STD_LOGIC; 
  signal N108 : STD_LOGIC; 
  signal adder_n0000_13_cyo : STD_LOGIC; 
  signal N128 : STD_LOGIC; 
  signal N83 : STD_LOGIC; 
  signal adder_n0002_6_cyo : STD_LOGIC; 
  signal N125 : STD_LOGIC; 
  signal N107 : STD_LOGIC; 
  signal adder_n0003_14_cyo : STD_LOGIC; 
  signal adder_n0002_11_cyo : STD_LOGIC; 
  signal N113 : STD_LOGIC; 
  signal adder_n0000_9_cyo : STD_LOGIC; 
  signal N84 : STD_LOGIC; 
  signal adder_n0000_11_cyo : STD_LOGIC; 
  signal N132 : STD_LOGIC; 
  signal N96 : STD_LOGIC; 
  signal adder_n0001_7_cyo : STD_LOGIC; 
  signal N131 : STD_LOGIC; 
  signal adder_n0000_15_cyo : STD_LOGIC; 
  signal adder_n0002_12_cyo : STD_LOGIC; 
  signal N82 : STD_LOGIC; 
  signal adder_n0002_14_cyo : STD_LOGIC; 
  signal adder_n0002_15_cyo : STD_LOGIC; 
  signal N114 : STD_LOGIC; 
  signal N116 : STD_LOGIC; 
  signal N117 : STD_LOGIC; 
  signal adder_n0000_7_cyo : STD_LOGIC; 
  signal adder_n0001_8_cyo : STD_LOGIC; 
  signal N134 : STD_LOGIC; 
  signal adder_n0001_11_cyo : STD_LOGIC; 
  signal adder_n0002_16_cyo : STD_LOGIC; 
  signal N129 : STD_LOGIC; 
  signal adder_n0001_6_cyo : STD_LOGIC; 
  signal adder_n0002_0_cyo : STD_LOGIC; 
  signal adder_n0002_13_cyo : STD_LOGIC; 
  signal adder_n0002_2_cyo : STD_LOGIC; 
  signal adder_n0002_10_cyo : STD_LOGIC; 
  signal adder_n0000_10_cyo : STD_LOGIC; 
  signal adder_n0000_14_cyo : STD_LOGIC; 
  signal N103 : STD_LOGIC; 
  signal N115 : STD_LOGIC; 
  signal N130 : STD_LOGIC; 
  signal N112 : STD_LOGIC; 
  signal N100 : STD_LOGIC; 
  signal adder_n0002_1_cyo : STD_LOGIC; 
  signal N95 : STD_LOGIC; 
  signal N102 : STD_LOGIC; 
  signal N92 : STD_LOGIC; 
  signal N101 : STD_LOGIC; 
  signal N133 : STD_LOGIC; 
  signal adder_n0001_2_cyo : STD_LOGIC; 
  signal adder_n0001_3_cyo : STD_LOGIC; 
  signal buffer_data_01_14_N0 : STD_LOGIC; 
  signal adder_n0000_6_cyo : STD_LOGIC; 
  signal N138 : STD_LOGIC; 
  signal adder_n0001_14_cyo : STD_LOGIC; 
  signal N137 : STD_LOGIC; 
  signal adder_n0001_13_cyo : STD_LOGIC; 
  signal N136 : STD_LOGIC; 
  signal adder_n0001_12_cyo : STD_LOGIC; 
  signal N135 : STD_LOGIC; 
  signal N9 : STD_LOGIC; 
  signal adder_n0006_0_cyo : STD_LOGIC; 
  signal N10 : STD_LOGIC; 
  signal adder_n0006_1_cyo : STD_LOGIC; 
  signal N11 : STD_LOGIC; 
  signal adder_n0006_2_cyo : STD_LOGIC; 
  signal N12 : STD_LOGIC; 
  signal adder_n0006_3_cyo : STD_LOGIC; 
  signal N13 : STD_LOGIC; 
  signal adder_n0006_4_cyo : STD_LOGIC; 
  signal N14 : STD_LOGIC; 
  signal adder_n0006_5_cyo : STD_LOGIC; 
  signal N15 : STD_LOGIC; 
  signal adder_n0006_6_cyo : STD_LOGIC; 
  signal N16 : STD_LOGIC; 
  signal adder_n0006_7_cyo : STD_LOGIC; 
  signal N17 : STD_LOGIC; 
  signal adder_n0006_8_cyo : STD_LOGIC; 
  signal N18 : STD_LOGIC; 
  signal adder_n0006_9_cyo : STD_LOGIC; 
  signal N19 : STD_LOGIC; 
  signal adder_n0006_10_cyo : STD_LOGIC; 
  signal N20 : STD_LOGIC; 
  signal adder_n0006_11_cyo : STD_LOGIC; 
  signal N21 : STD_LOGIC; 
  signal adder_n0006_12_cyo : STD_LOGIC; 
  signal N22 : STD_LOGIC; 
  signal adder_n0006_13_cyo : STD_LOGIC; 
  signal N23 : STD_LOGIC; 
  signal adder_n0006_14_cyo : STD_LOGIC; 
  signal N24 : STD_LOGIC; 
  signal adder_n0006_15_cyo : STD_LOGIC; 
  signal N25 : STD_LOGIC; 
  signal adder_n0006_16_cyo : STD_LOGIC; 
  signal N111 : STD_LOGIC; 
  signal adder_n0002_9_cyo : STD_LOGIC; 
  signal N110 : STD_LOGIC; 
  signal adder_n0002_8_cyo : STD_LOGIC; 
  signal N109 : STD_LOGIC; 
  signal N31 : STD_LOGIC; 
  signal adder_n0005_0_cyo : STD_LOGIC; 
  signal N32 : STD_LOGIC; 
  signal adder_n0005_1_cyo : STD_LOGIC; 
  signal N33 : STD_LOGIC; 
  signal adder_n0005_2_cyo : STD_LOGIC; 
  signal N34 : STD_LOGIC; 
  signal adder_n0005_3_cyo : STD_LOGIC; 
  signal N35 : STD_LOGIC; 
  signal adder_n0005_4_cyo : STD_LOGIC; 
  signal N36 : STD_LOGIC; 
  signal adder_n0005_5_cyo : STD_LOGIC; 
  signal N37 : STD_LOGIC; 
  signal adder_n0005_6_cyo : STD_LOGIC; 
  signal N38 : STD_LOGIC; 
  signal adder_n0005_7_cyo : STD_LOGIC; 
  signal N39 : STD_LOGIC; 
  signal adder_n0005_8_cyo : STD_LOGIC; 
  signal N40 : STD_LOGIC; 
  signal adder_n0005_9_cyo : STD_LOGIC; 
  signal N41 : STD_LOGIC; 
  signal adder_n0005_10_cyo : STD_LOGIC; 
  signal N42 : STD_LOGIC; 
  signal adder_n0005_11_cyo : STD_LOGIC; 
  signal N43 : STD_LOGIC; 
  signal adder_n0005_12_cyo : STD_LOGIC; 
  signal N44 : STD_LOGIC; 
  signal adder_n0005_13_cyo : STD_LOGIC; 
  signal N45 : STD_LOGIC; 
  signal adder_n0005_14_cyo : STD_LOGIC; 
  signal N46 : STD_LOGIC; 
  signal N47 : STD_LOGIC; 
  signal adder_n0004_0_cyo : STD_LOGIC; 
  signal N48 : STD_LOGIC; 
  signal adder_n0004_1_cyo : STD_LOGIC; 
  signal N49 : STD_LOGIC; 
  signal adder_n0004_2_cyo : STD_LOGIC; 
  signal N50 : STD_LOGIC; 
  signal adder_n0004_3_cyo : STD_LOGIC; 
  signal N51 : STD_LOGIC; 
  signal adder_n0004_4_cyo : STD_LOGIC; 
  signal N52 : STD_LOGIC; 
  signal adder_n0004_5_cyo : STD_LOGIC; 
  signal N53 : STD_LOGIC; 
  signal adder_n0004_6_cyo : STD_LOGIC; 
  signal N54 : STD_LOGIC; 
  signal adder_n0004_7_cyo : STD_LOGIC; 
  signal N55 : STD_LOGIC; 
  signal adder_n0004_8_cyo : STD_LOGIC; 
  signal N56 : STD_LOGIC; 
  signal adder_n0004_9_cyo : STD_LOGIC; 
  signal N57 : STD_LOGIC; 
  signal adder_n0004_10_cyo : STD_LOGIC; 
  signal N58 : STD_LOGIC; 
  signal adder_n0004_11_cyo : STD_LOGIC; 
  signal N59 : STD_LOGIC; 
  signal adder_n0004_12_cyo : STD_LOGIC; 
  signal N60 : STD_LOGIC; 
  signal adder_n0004_13_cyo : STD_LOGIC; 
  signal N61 : STD_LOGIC; 
  signal adder_n0004_14_cyo : STD_LOGIC; 
  signal N62 : STD_LOGIC; 
  signal adder_n0004_15_cyo : STD_LOGIC; 
  signal N63 : STD_LOGIC; 
  signal adder_n0004_16_cyo : STD_LOGIC; 
  signal N64 : STD_LOGIC; 
  signal adder_n0004_17_cyo : STD_LOGIC; 
  signal N106 : STD_LOGIC; 
  signal adder_n0002_4_cyo : STD_LOGIC; 
  signal N105 : STD_LOGIC; 
  signal N69 : STD_LOGIC; 
  signal adder_n0003_0_cyo : STD_LOGIC; 
  signal N70 : STD_LOGIC; 
  signal adder_n0003_1_cyo : STD_LOGIC; 
  signal N71 : STD_LOGIC; 
  signal adder_n0003_2_cyo : STD_LOGIC; 
  signal N72 : STD_LOGIC; 
  signal adder_n0003_3_cyo : STD_LOGIC; 
  signal N73 : STD_LOGIC; 
  signal adder_n0003_4_cyo : STD_LOGIC; 
  signal N74 : STD_LOGIC; 
  signal adder_n0003_5_cyo : STD_LOGIC; 
  signal N75 : STD_LOGIC; 
  signal adder_n0003_6_cyo : STD_LOGIC; 
  signal N76 : STD_LOGIC; 
  signal adder_n0003_7_cyo : STD_LOGIC; 
  signal N77 : STD_LOGIC; 
  signal adder_n0003_8_cyo : STD_LOGIC; 
  signal N78 : STD_LOGIC; 
  signal adder_n0003_9_cyo : STD_LOGIC; 
  signal N79 : STD_LOGIC; 
  signal adder_n0003_10_cyo : STD_LOGIC; 
  signal N80 : STD_LOGIC; 
  signal adder_n0003_11_cyo : STD_LOGIC; 
  signal N81 : STD_LOGIC; 
  signal adder_n0003_12_cyo : STD_LOGIC; 
  signal N85 : STD_LOGIC; 
  signal adder_n0000_0_cyo : STD_LOGIC; 
  signal N86 : STD_LOGIC; 
  signal adder_n0000_1_cyo : STD_LOGIC; 
  signal N87 : STD_LOGIC; 
  signal adder_n0000_2_cyo : STD_LOGIC; 
  signal N88 : STD_LOGIC; 
  signal adder_n0000_3_cyo : STD_LOGIC; 
  signal N89 : STD_LOGIC; 
  signal adder_n0000_4_cyo : STD_LOGIC; 
  signal N90 : STD_LOGIC; 
  signal adder_n0000_5_cyo : STD_LOGIC; 
  signal N91 : STD_LOGIC; 
  signal buffer_data_00_03 : STD_LOGIC_VECTOR ( 17 downto 0 ); 
  signal buffer_data_00_01 : STD_LOGIC_VECTOR ( 16 downto 0 ); 
  signal Q_n0006 : STD_LOGIC_VECTOR ( 16 downto 1 ); 
  signal Q_n0005 : STD_LOGIC_VECTOR ( 15 downto 1 ); 
  signal Q_n0004 : STD_LOGIC_VECTOR ( 17 downto 1 ); 
  signal buffer_data_06_07 : STD_LOGIC_VECTOR ( 16 downto 0 ); 
  signal buffer_data_04_07 : STD_LOGIC_VECTOR ( 17 downto 0 ); 
  signal buffer_data_07 : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal buffer_data_03 : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal Q_n0003 : STD_LOGIC_VECTOR ( 15 downto 1 ); 
  signal buffer_data_04 : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal buffer_data_04_05 : STD_LOGIC_VECTOR ( 16 downto 0 ); 
  signal buffer_data_02_03 : STD_LOGIC_VECTOR ( 16 downto 0 ); 
  signal Q_n0001 : STD_LOGIC_VECTOR ( 15 downto 1 ); 
  signal Q_n0000 : STD_LOGIC_VECTOR ( 15 downto 1 ); 
  signal buffer_data_00 : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal Q_n0002 : STD_LOGIC_VECTOR ( 16 downto 1 ); 
  signal buffer_data_02 : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal buffer_data_01 : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal NlwRenamedSig_OI_out_data : STD_LOGIC_VECTOR ( 19 downto 19 ); 
  signal buffer_data_05 : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal buffer_data_06 : STD_LOGIC_VECTOR ( 15 downto 0 ); 
begin
  out_data(21) <= NlwRenamedSig_OI_out_data(19);
  out_data(20) <= NlwRenamedSig_OI_out_data(19);
  out_data(19) <= NlwRenamedSig_OI_out_data(19);
  XST_GND : GND
    port map (
      G => NlwRenamedSig_OI_out_data(19)
    );
  buffer_data_03_9 : FDC
    port map (
      D => in_data_03(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(9)
    );
  buffer_data_05_13 : FDC
    port map (
      D => in_data_05(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(13)
    );
  adder_n0001_15_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(15),
      I1 => buffer_data_05(15),
      LO => N138
    );
  buffer_data_01_11 : FDC
    port map (
      D => in_data_01(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(11)
    );
  adder_n0001_14_xor : XORCY
    port map (
      CI => adder_n0001_13_cyo,
      LI => N137,
      O => Q_n0001(14)
    );
  buffer_data_00_6 : FDC
    port map (
      D => in_data_00(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(6)
    );
  buffer_data_03_8 : FDC
    port map (
      D => in_data_03(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(8)
    );
  buffer_data_05_12 : FDC
    port map (
      D => in_data_05(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(12)
    );
  buffer_data_01_10 : FDC
    port map (
      D => in_data_01(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(10)
    );
  buffer_data_00_5 : FDC
    port map (
      D => in_data_00(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(5)
    );
  adder_n0001_14_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(14),
      I1 => buffer_data_05(14),
      LO => N137
    );
  buffer_data_03_7 : FDC
    port map (
      D => in_data_03(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(7)
    );
  buffer_data_05_11 : FDC
    port map (
      D => in_data_05(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(11)
    );
  buffer_data_06_9 : FDC
    port map (
      D => in_data_06(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(9)
    );
  buffer_data_00_4 : FDC
    port map (
      D => in_data_00(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(4)
    );
  buffer_data_03_6 : FDC
    port map (
      D => in_data_03(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(6)
    );
  buffer_data_05_10 : FDC
    port map (
      D => in_data_05(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(10)
    );
  buffer_data_06_8 : FDC
    port map (
      D => in_data_06(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(8)
    );
  adder_n0001_13_xor : XORCY
    port map (
      CI => adder_n0001_12_cyo,
      LI => N136,
      O => Q_n0001(13)
    );
  buffer_data_00_3 : FDC
    port map (
      D => in_data_00(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(3)
    );
  buffer_data_03_5 : FDC
    port map (
      D => in_data_03(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(5)
    );
  buffer_data_06_7 : FDC
    port map (
      D => in_data_06(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(7)
    );
  buffer_data_00_2 : FDC
    port map (
      D => in_data_00(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(2)
    );
  buffer_data_03_4 : FDC
    port map (
      D => in_data_03(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(4)
    );
  buffer_data_06_6 : FDC
    port map (
      D => in_data_06(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(6)
    );
  buffer_data_00_15 : FDC
    port map (
      D => in_data_00(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(15)
    );
  buffer_data_00_1 : FDC
    port map (
      D => in_data_00(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(1)
    );
  buffer_data_03_3 : FDC
    port map (
      D => in_data_03(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(3)
    );
  buffer_data_06_5 : FDC
    port map (
      D => in_data_06(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(5)
    );
  buffer_data_00_14 : FDC
    port map (
      D => in_data_00(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(14)
    );
  buffer_data_00_0 : FDC
    port map (
      D => in_data_00(0),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(0)
    );
  buffer_data_03_2 : FDC
    port map (
      D => in_data_03(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(2)
    );
  buffer_data_04_15 : FDC
    port map (
      D => in_data_04(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(15)
    );
  buffer_data_06_4 : FDC
    port map (
      D => in_data_06(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(4)
    );
  buffer_data_00_13 : FDC
    port map (
      D => in_data_00(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(13)
    );
  buffer_data_03_1 : FDC
    port map (
      D => in_data_03(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(1)
    );
  buffer_data_04_14 : FDC
    port map (
      D => in_data_04(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(14)
    );
  buffer_data_06_3 : FDC
    port map (
      D => in_data_06(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(3)
    );
  buffer_data_00_12 : FDC
    port map (
      D => in_data_00(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(12)
    );
  buffer_data_03_0 : FDC
    port map (
      D => in_data_03(0),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(0)
    );
  buffer_data_04_13 : FDC
    port map (
      D => in_data_04(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(13)
    );
  buffer_data_06_2 : FDC
    port map (
      D => in_data_06(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(2)
    );
  buffer_data_00_11 : FDC
    port map (
      D => in_data_00(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(11)
    );
  buffer_data_04_12 : FDC
    port map (
      D => in_data_04(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(12)
    );
  buffer_data_06_1 : FDC
    port map (
      D => in_data_06(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(1)
    );
  buffer_data_00_10 : FDC
    port map (
      D => in_data_00(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(10)
    );
  buffer_data_04_11 : FDC
    port map (
      D => in_data_04(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(11)
    );
  adder_n0001_15_cy : MUXCY
    port map (
      CI => adder_n0001_14_cyo,
      DI => buffer_data_04(15),
      S => N138,
      O => adder_n0001_15_cyo
    );
  adder_n0005_15_xor : XORCY
    port map (
      CI => adder_n0005_14_cyo,
      LI => N46,
      O => Q_n0005(15)
    );
  adder_n0001_14_cy : MUXCY
    port map (
      CI => adder_n0001_13_cyo,
      DI => buffer_data_04(14),
      S => N137,
      O => adder_n0001_14_cyo
    );
  adder_n0003_15_xor : XORCY
    port map (
      CI => adder_n0003_14_cyo,
      LI => N84,
      O => Q_n0003(15)
    );
  adder_n0001_13_cy : MUXCY
    port map (
      CI => adder_n0001_12_cyo,
      DI => buffer_data_04(13),
      S => N136,
      O => adder_n0001_13_cyo
    );
  adder_n0001_15_xor : XORCY
    port map (
      CI => adder_n0001_14_cyo,
      LI => N138,
      O => Q_n0001(15)
    );
  adder_n0000_15_xor : XORCY
    port map (
      CI => adder_n0000_14_cyo,
      LI => N100,
      O => Q_n0000(15)
    );
  buffer_data_01_14 : FDC
    port map (
      D => in_data_01(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(14)
    );
  buffer_data_05_0 : FDC
    port map (
      D => in_data_05(0),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(0)
    );
  buffer_data_00_9 : FDC
    port map (
      D => in_data_00(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(9)
    );
  buffer_data_05_15 : FDC
    port map (
      D => in_data_05(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(15)
    );
  buffer_data_01_13 : FDC
    port map (
      D => in_data_01(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(13)
    );
  buffer_data_00_8 : FDC
    port map (
      D => in_data_00(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(8)
    );
  buffer_data_05_14 : FDC
    port map (
      D => in_data_05(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(14)
    );
  buffer_data_01_12 : FDC
    port map (
      D => in_data_01(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(12)
    );
  buffer_data_00_7 : FDC
    port map (
      D => in_data_00(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00(7)
    );
  buffer_data_05_1 : FDC
    port map (
      D => in_data_05(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(1)
    );
  buffer_data_01_15 : FDC
    port map (
      D => in_data_01(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(15)
    );
  buffer_data_05_2 : FDC
    port map (
      D => in_data_05(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(2)
    );
  buffer_data_02_0 : FDC
    port map (
      D => in_data_02(0),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(0)
    );
  buffer_data_05_3 : FDC
    port map (
      D => in_data_05(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(3)
    );
  buffer_data_02_1 : FDC
    port map (
      D => in_data_02(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(1)
    );
  buffer_data_06_10 : FDC
    port map (
      D => in_data_06(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(10)
    );
  buffer_data_05_4 : FDC
    port map (
      D => in_data_05(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(4)
    );
  buffer_data_02_2 : FDC
    port map (
      D => in_data_02(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(2)
    );
  buffer_data_06_11 : FDC
    port map (
      D => in_data_06(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(11)
    );
  buffer_data_05_5 : FDC
    port map (
      D => in_data_05(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(5)
    );
  buffer_data_02_3 : FDC
    port map (
      D => in_data_02(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(3)
    );
  buffer_data_02_10 : FDC
    port map (
      D => in_data_02(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(10)
    );
  buffer_data_06_12 : FDC
    port map (
      D => in_data_06(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(12)
    );
  buffer_data_05_6 : FDC
    port map (
      D => in_data_05(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(6)
    );
  buffer_data_02_4 : FDC
    port map (
      D => in_data_02(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(4)
    );
  buffer_data_02_11 : FDC
    port map (
      D => in_data_02(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(11)
    );
  buffer_data_06_13 : FDC
    port map (
      D => in_data_06(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(13)
    );
  buffer_data_05_7 : FDC
    port map (
      D => in_data_05(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(7)
    );
  buffer_data_02_5 : FDC
    port map (
      D => in_data_02(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(5)
    );
  buffer_data_02_12 : FDC
    port map (
      D => in_data_02(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(12)
    );
  buffer_data_06_14 : FDC
    port map (
      D => in_data_06(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(14)
    );
  buffer_data_05_8 : FDC
    port map (
      D => in_data_05(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(8)
    );
  buffer_data_02_6 : FDC
    port map (
      D => in_data_02(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(6)
    );
  buffer_data_02_13 : FDC
    port map (
      D => in_data_02(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(13)
    );
  buffer_data_06_15 : FDC
    port map (
      D => in_data_06(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(15)
    );
  adder_n0001_13_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(13),
      I1 => buffer_data_05(13),
      LO => N136
    );
  buffer_data_05_9 : FDC
    port map (
      D => in_data_05(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_05(9)
    );
  buffer_data_02_7 : FDC
    port map (
      D => in_data_02(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(7)
    );
  buffer_data_02_14 : FDC
    port map (
      D => in_data_02(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(14)
    );
  buffer_data_02_8 : FDC
    port map (
      D => in_data_02(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(8)
    );
  buffer_data_02_15 : FDC
    port map (
      D => in_data_02(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(15)
    );
  buffer_data_02_9 : FDC
    port map (
      D => in_data_02(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02(9)
    );
  buffer_data_07_0 : FDC
    port map (
      D => in_data_07(0),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(0)
    );
  buffer_data_07_1 : FDC
    port map (
      D => in_data_07(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(1)
    );
  buffer_data_07_10 : FDC
    port map (
      D => in_data_07(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(10)
    );
  buffer_data_07_2 : FDC
    port map (
      D => in_data_07(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(2)
    );
  buffer_data_04_0 : FDC
    port map (
      D => in_data_04(0),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(0)
    );
  buffer_data_07_11 : FDC
    port map (
      D => in_data_07(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(11)
    );
  buffer_data_07_3 : FDC
    port map (
      D => in_data_07(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(3)
    );
  buffer_data_04_1 : FDC
    port map (
      D => in_data_04(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(1)
    );
  buffer_data_03_10 : FDC
    port map (
      D => in_data_03(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(10)
    );
  buffer_data_07_12 : FDC
    port map (
      D => in_data_07(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(12)
    );
  buffer_data_07_4 : FDC
    port map (
      D => in_data_07(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(4)
    );
  buffer_data_04_2 : FDC
    port map (
      D => in_data_04(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(2)
    );
  buffer_data_03_11 : FDC
    port map (
      D => in_data_03(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(11)
    );
  buffer_data_01_0 : FDC
    port map (
      D => in_data_01(0),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(0)
    );
  buffer_data_07_13 : FDC
    port map (
      D => in_data_07(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(13)
    );
  buffer_data_07_5 : FDC
    port map (
      D => in_data_07(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(5)
    );
  buffer_data_04_3 : FDC
    port map (
      D => in_data_04(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(3)
    );
  buffer_data_03_12 : FDC
    port map (
      D => in_data_03(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(12)
    );
  buffer_data_01_1 : FDC
    port map (
      D => in_data_01(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(1)
    );
  buffer_data_07_14 : FDC
    port map (
      D => in_data_07(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(14)
    );
  buffer_data_07_6 : FDC
    port map (
      D => in_data_07(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(6)
    );
  buffer_data_04_4 : FDC
    port map (
      D => in_data_04(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(4)
    );
  buffer_data_03_13 : FDC
    port map (
      D => in_data_03(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(13)
    );
  buffer_data_01_2 : FDC
    port map (
      D => in_data_01(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(2)
    );
  buffer_data_07_15 : FDC
    port map (
      D => in_data_07(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(15)
    );
  buffer_data_07_7 : FDC
    port map (
      D => in_data_07(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(7)
    );
  buffer_data_04_5 : FDC
    port map (
      D => in_data_04(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(5)
    );
  buffer_data_03_14 : FDC
    port map (
      D => in_data_03(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(14)
    );
  buffer_data_01_3 : FDC
    port map (
      D => in_data_01(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(3)
    );
  buffer_data_07_8 : FDC
    port map (
      D => in_data_07(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(8)
    );
  buffer_data_04_6 : FDC
    port map (
      D => in_data_04(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(6)
    );
  buffer_data_03_15 : FDC
    port map (
      D => in_data_03(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_03(15)
    );
  buffer_data_01_4 : FDC
    port map (
      D => in_data_01(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(4)
    );
  buffer_data_07_9 : FDC
    port map (
      D => in_data_07(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_07(9)
    );
  buffer_data_04_7 : FDC
    port map (
      D => in_data_04(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(7)
    );
  adder_n0001_12_xor : XORCY
    port map (
      CI => adder_n0001_11_cyo,
      LI => N135,
      O => Q_n0001(12)
    );
  buffer_data_01_5 : FDC
    port map (
      D => in_data_01(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(5)
    );
  adder_n0001_12_cy : MUXCY
    port map (
      CI => adder_n0001_11_cyo,
      DI => buffer_data_04(12),
      S => N135,
      O => adder_n0001_12_cyo
    );
  buffer_data_04_8 : FDC
    port map (
      D => in_data_04(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(8)
    );
  buffer_data_01_6 : FDC
    port map (
      D => in_data_01(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(6)
    );
  buffer_data_04_9 : FDC
    port map (
      D => in_data_04(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(9)
    );
  buffer_data_01_7 : FDC
    port map (
      D => in_data_01(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(7)
    );
  buffer_data_01_8 : FDC
    port map (
      D => in_data_01(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(8)
    );
  buffer_data_04_10 : FDC
    port map (
      D => in_data_04(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04(10)
    );
  buffer_data_01_9 : FDC
    port map (
      D => in_data_01(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_01(9)
    );
  buffer_data_06_0 : FDC
    port map (
      D => in_data_06(0),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06(0)
    );
  buffer_data_01_14_N01_INV_0 : INV
    port map (
      I => in_reset_n,
      O => buffer_data_01_14_N0
    );
  adder_n0001_11_xor : XORCY
    port map (
      CI => adder_n0001_10_cyo,
      LI => N134,
      O => Q_n0001(11)
    );
  buffer_data_00_01_15 : FDC
    port map (
      D => Q_n0005(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(15)
    );
  buffer_data_00_01_0 : FDC
    port map (
      D => N31,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(0)
    );
  buffer_data_00_01_1 : FDC
    port map (
      D => Q_n0005(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(1)
    );
  buffer_data_00_01_2 : FDC
    port map (
      D => Q_n0005(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(2)
    );
  buffer_data_00_01_3 : FDC
    port map (
      D => Q_n0005(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(3)
    );
  buffer_data_00_01_4 : FDC
    port map (
      D => Q_n0005(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(4)
    );
  buffer_data_00_01_5 : FDC
    port map (
      D => Q_n0005(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(5)
    );
  buffer_data_00_01_6 : FDC
    port map (
      D => Q_n0005(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(6)
    );
  buffer_data_00_01_8 : FDC
    port map (
      D => Q_n0005(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(8)
    );
  buffer_data_00_01_10 : FDC
    port map (
      D => Q_n0005(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(10)
    );
  buffer_data_00_01_11 : FDC
    port map (
      D => Q_n0005(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(11)
    );
  buffer_data_00_01_12 : FDC
    port map (
      D => Q_n0005(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(12)
    );
  buffer_data_00_01_13 : FDC
    port map (
      D => Q_n0005(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(13)
    );
  buffer_data_00_01_14 : FDC
    port map (
      D => Q_n0005(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(14)
    );
  buffer_data_00_01_16 : FDC
    port map (
      D => adder_n0005_15_cyo,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(16)
    );
  adder_n0001_11_cy : MUXCY
    port map (
      CI => adder_n0001_10_cyo,
      DI => buffer_data_04(11),
      S => N134,
      O => adder_n0001_11_cyo
    );
  adder_n0001_11_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(11),
      I1 => buffer_data_05(11),
      LO => N134
    );
  adder_n0001_10_xor : XORCY
    port map (
      CI => adder_n0001_9_cyo,
      LI => N133,
      O => Q_n0001(10)
    );
  adder_n0001_10_cy : MUXCY
    port map (
      CI => adder_n0001_9_cyo,
      DI => buffer_data_04(10),
      S => N133,
      O => adder_n0001_10_cyo
    );
  out_data_1 : FDC
    port map (
      D => Q_n0004(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(1)
    );
  out_data_0 : FDC
    port map (
      D => N47,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(0)
    );
  out_data_2 : FDC
    port map (
      D => Q_n0004(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(2)
    );
  out_data_3 : FDC
    port map (
      D => Q_n0004(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(3)
    );
  out_data_4 : FDC
    port map (
      D => Q_n0004(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(4)
    );
  out_data_5 : FDC
    port map (
      D => Q_n0004(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(5)
    );
  out_data_6 : FDC
    port map (
      D => Q_n0004(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(6)
    );
  out_data_7 : FDC
    port map (
      D => Q_n0004(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(7)
    );
  out_data_8 : FDC
    port map (
      D => Q_n0004(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(8)
    );
  out_data_9 : FDC
    port map (
      D => Q_n0004(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(9)
    );
  out_data_10 : FDC
    port map (
      D => Q_n0004(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(10)
    );
  out_data_11 : FDC
    port map (
      D => Q_n0004(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(11)
    );
  out_data_12 : FDC
    port map (
      D => Q_n0004(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(12)
    );
  out_data_13 : FDC
    port map (
      D => Q_n0004(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(13)
    );
  out_data_14 : FDC
    port map (
      D => Q_n0004(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(14)
    );
  out_data_15 : FDC
    port map (
      D => Q_n0004(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(15)
    );
  out_data_16 : FDC
    port map (
      D => Q_n0004(16),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(16)
    );
  out_data_17 : FDC
    port map (
      D => Q_n0004(17),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(17)
    );
  out_data_18 : FDC
    port map (
      D => adder_n0004_17_cyo,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => out_data(18)
    );
  adder_n0001_9_xor : XORCY
    port map (
      CI => adder_n0001_8_cyo,
      LI => N132,
      O => Q_n0001(9)
    );
  adder_n0001_9_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(9),
      I1 => buffer_data_05(9),
      LO => N132
    );
  buffer_data_06_07_16 : FDC
    port map (
      D => adder_n0003_15_cyo,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(16)
    );
  buffer_data_06_07_0 : FDC
    port map (
      D => N69,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(0)
    );
  buffer_data_06_07_1 : FDC
    port map (
      D => Q_n0003(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(1)
    );
  buffer_data_06_07_2 : FDC
    port map (
      D => Q_n0003(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(2)
    );
  buffer_data_06_07_3 : FDC
    port map (
      D => Q_n0003(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(3)
    );
  buffer_data_06_07_4 : FDC
    port map (
      D => Q_n0003(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(4)
    );
  buffer_data_06_07_5 : FDC
    port map (
      D => Q_n0003(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(5)
    );
  buffer_data_06_07_6 : FDC
    port map (
      D => Q_n0003(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(6)
    );
  buffer_data_06_07_7 : FDC
    port map (
      D => Q_n0003(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(7)
    );
  buffer_data_06_07_8 : FDC
    port map (
      D => Q_n0003(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(8)
    );
  buffer_data_06_07_9 : FDC
    port map (
      D => Q_n0003(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(9)
    );
  buffer_data_06_07_10 : FDC
    port map (
      D => Q_n0003(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(10)
    );
  buffer_data_06_07_11 : FDC
    port map (
      D => Q_n0003(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(11)
    );
  buffer_data_06_07_12 : FDC
    port map (
      D => Q_n0003(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(12)
    );
  buffer_data_06_07_13 : FDC
    port map (
      D => Q_n0003(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(13)
    );
  buffer_data_06_07_14 : FDC
    port map (
      D => Q_n0003(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(14)
    );
  buffer_data_06_07_15 : FDC
    port map (
      D => Q_n0003(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_06_07(15)
    );
  adder_n0001_8_xor : XORCY
    port map (
      CI => adder_n0001_7_cyo,
      LI => N131,
      O => Q_n0001(8)
    );
  adder_n0001_8_cy : MUXCY
    port map (
      CI => adder_n0001_7_cyo,
      DI => buffer_data_04(8),
      S => N131,
      O => adder_n0001_8_cyo
    );
  adder_n0001_8_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(8),
      I1 => buffer_data_05(8),
      LO => N131
    );
  adder_n0001_7_xor : XORCY
    port map (
      CI => adder_n0001_6_cyo,
      LI => N130,
      O => Q_n0001(7)
    );
  buffer_data_04_07_0 : FDC
    port map (
      D => N101,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(0)
    );
  buffer_data_04_07_1 : FDC
    port map (
      D => Q_n0002(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(1)
    );
  buffer_data_04_07_2 : FDC
    port map (
      D => Q_n0002(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(2)
    );
  buffer_data_04_07_3 : FDC
    port map (
      D => Q_n0002(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(3)
    );
  buffer_data_04_07_4 : FDC
    port map (
      D => Q_n0002(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(4)
    );
  buffer_data_04_07_5 : FDC
    port map (
      D => Q_n0002(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(5)
    );
  buffer_data_04_07_6 : FDC
    port map (
      D => Q_n0002(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(6)
    );
  buffer_data_04_07_7 : FDC
    port map (
      D => Q_n0002(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(7)
    );
  buffer_data_04_07_8 : FDC
    port map (
      D => Q_n0002(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(8)
    );
  buffer_data_04_07_9 : FDC
    port map (
      D => Q_n0002(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(9)
    );
  buffer_data_04_07_10 : FDC
    port map (
      D => Q_n0002(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(10)
    );
  buffer_data_04_07_11 : FDC
    port map (
      D => Q_n0002(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(11)
    );
  buffer_data_04_07_12 : FDC
    port map (
      D => Q_n0002(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(12)
    );
  buffer_data_04_07_13 : FDC
    port map (
      D => Q_n0002(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(13)
    );
  buffer_data_04_07_14 : FDC
    port map (
      D => Q_n0002(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(14)
    );
  buffer_data_04_07_15 : FDC
    port map (
      D => Q_n0002(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(15)
    );
  buffer_data_04_07_16 : FDC
    port map (
      D => Q_n0002(16),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(16)
    );
  buffer_data_04_07_17 : FDC
    port map (
      D => adder_n0002_16_cyo,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_07(17)
    );
  adder_n0001_7_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(7),
      I1 => buffer_data_05(7),
      LO => N130
    );
  adder_n0001_6_cy : MUXCY
    port map (
      CI => adder_n0001_5_cyo,
      DI => buffer_data_04(6),
      S => N129,
      O => adder_n0001_6_cyo
    );
  adder_n0001_5_xor : XORCY
    port map (
      CI => adder_n0001_4_cyo,
      LI => N128,
      O => Q_n0001(5)
    );
  buffer_data_04_05_16 : FDC
    port map (
      D => adder_n0001_15_cyo,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(16)
    );
  buffer_data_04_05_0 : FDC
    port map (
      D => N123,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(0)
    );
  buffer_data_04_05_1 : FDC
    port map (
      D => Q_n0001(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(1)
    );
  buffer_data_04_05_2 : FDC
    port map (
      D => Q_n0001(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(2)
    );
  buffer_data_04_05_3 : FDC
    port map (
      D => Q_n0001(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(3)
    );
  buffer_data_04_05_4 : FDC
    port map (
      D => Q_n0001(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(4)
    );
  buffer_data_04_05_5 : FDC
    port map (
      D => Q_n0001(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(5)
    );
  buffer_data_04_05_6 : FDC
    port map (
      D => Q_n0001(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(6)
    );
  buffer_data_04_05_7 : FDC
    port map (
      D => Q_n0001(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(7)
    );
  buffer_data_04_05_8 : FDC
    port map (
      D => Q_n0001(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(8)
    );
  buffer_data_04_05_9 : FDC
    port map (
      D => Q_n0001(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(9)
    );
  buffer_data_04_05_10 : FDC
    port map (
      D => Q_n0001(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(10)
    );
  buffer_data_04_05_11 : FDC
    port map (
      D => Q_n0001(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(11)
    );
  buffer_data_04_05_12 : FDC
    port map (
      D => Q_n0001(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(12)
    );
  buffer_data_04_05_13 : FDC
    port map (
      D => Q_n0001(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(13)
    );
  buffer_data_04_05_14 : FDC
    port map (
      D => Q_n0001(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(14)
    );
  buffer_data_04_05_15 : FDC
    port map (
      D => Q_n0001(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_04_05(15)
    );
  adder_n0001_5_cy : MUXCY
    port map (
      CI => adder_n0001_4_cyo,
      DI => buffer_data_04(5),
      S => N128,
      O => adder_n0001_5_cyo
    );
  adder_n0001_5_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(5),
      I1 => buffer_data_05(5),
      LO => N128
    );
  adder_n0001_4_xor : XORCY
    port map (
      CI => adder_n0001_3_cyo,
      LI => N127,
      O => Q_n0001(4)
    );
  adder_n0001_4_cy : MUXCY
    port map (
      CI => adder_n0001_3_cyo,
      DI => buffer_data_04(4),
      S => N127,
      O => adder_n0001_4_cyo
    );
  adder_n0001_3_xor : XORCY
    port map (
      CI => adder_n0001_2_cyo,
      LI => N126,
      O => Q_n0001(3)
    );
  buffer_data_02_03_0 : FDC
    port map (
      D => N85,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(0)
    );
  buffer_data_02_03_1 : FDC
    port map (
      D => Q_n0000(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(1)
    );
  buffer_data_02_03_2 : FDC
    port map (
      D => Q_n0000(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(2)
    );
  buffer_data_02_03_3 : FDC
    port map (
      D => Q_n0000(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(3)
    );
  buffer_data_02_03_4 : FDC
    port map (
      D => Q_n0000(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(4)
    );
  buffer_data_02_03_5 : FDC
    port map (
      D => Q_n0000(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(5)
    );
  buffer_data_02_03_6 : FDC
    port map (
      D => Q_n0000(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(6)
    );
  buffer_data_02_03_7 : FDC
    port map (
      D => Q_n0000(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(7)
    );
  buffer_data_02_03_8 : FDC
    port map (
      D => Q_n0000(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(8)
    );
  buffer_data_02_03_9 : FDC
    port map (
      D => Q_n0000(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(9)
    );
  buffer_data_02_03_10 : FDC
    port map (
      D => Q_n0000(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(10)
    );
  buffer_data_02_03_11 : FDC
    port map (
      D => Q_n0000(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(11)
    );
  buffer_data_02_03_12 : FDC
    port map (
      D => Q_n0000(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(12)
    );
  buffer_data_02_03_13 : FDC
    port map (
      D => Q_n0000(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(13)
    );
  buffer_data_02_03_14 : FDC
    port map (
      D => Q_n0000(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(14)
    );
  buffer_data_02_03_15 : FDC
    port map (
      D => Q_n0000(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(15)
    );
  buffer_data_02_03_16 : FDC
    port map (
      D => adder_n0000_15_cyo,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_02_03(16)
    );
  adder_n0001_3_cy : MUXCY
    port map (
      CI => adder_n0001_2_cyo,
      DI => buffer_data_04(3),
      S => N126,
      O => adder_n0001_3_cyo
    );
  adder_n0001_3_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(3),
      I1 => buffer_data_05(3),
      LO => N126
    );
  adder_n0001_2_xor : XORCY
    port map (
      CI => adder_n0001_1_cyo,
      LI => N125,
      O => Q_n0001(2)
    );
  adder_n0001_2_cy : MUXCY
    port map (
      CI => adder_n0001_1_cyo,
      DI => buffer_data_04(2),
      S => N125,
      O => adder_n0001_2_cyo
    );
  buffer_data_00_01_7 : FDC
    port map (
      D => Q_n0005(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(7)
    );
  buffer_data_00_01_9 : FDC
    port map (
      D => Q_n0005(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_01(9)
    );
  buffer_data_00_03_0 : FDC
    port map (
      D => N9,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(0)
    );
  buffer_data_00_03_1 : FDC
    port map (
      D => Q_n0006(1),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(1)
    );
  buffer_data_00_03_2 : FDC
    port map (
      D => Q_n0006(2),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(2)
    );
  buffer_data_00_03_3 : FDC
    port map (
      D => Q_n0006(3),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(3)
    );
  buffer_data_00_03_4 : FDC
    port map (
      D => Q_n0006(4),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(4)
    );
  buffer_data_00_03_5 : FDC
    port map (
      D => Q_n0006(5),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(5)
    );
  buffer_data_00_03_6 : FDC
    port map (
      D => Q_n0006(6),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(6)
    );
  buffer_data_00_03_7 : FDC
    port map (
      D => Q_n0006(7),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(7)
    );
  buffer_data_00_03_8 : FDC
    port map (
      D => Q_n0006(8),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(8)
    );
  buffer_data_00_03_9 : FDC
    port map (
      D => Q_n0006(9),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(9)
    );
  buffer_data_00_03_10 : FDC
    port map (
      D => Q_n0006(10),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(10)
    );
  buffer_data_00_03_11 : FDC
    port map (
      D => Q_n0006(11),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(11)
    );
  buffer_data_00_03_12 : FDC
    port map (
      D => Q_n0006(12),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(12)
    );
  buffer_data_00_03_13 : FDC
    port map (
      D => Q_n0006(13),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(13)
    );
  buffer_data_00_03_14 : FDC
    port map (
      D => Q_n0006(14),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(14)
    );
  buffer_data_00_03_15 : FDC
    port map (
      D => Q_n0006(15),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(15)
    );
  buffer_data_00_03_16 : FDC
    port map (
      D => Q_n0006(16),
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(16)
    );
  buffer_data_00_03_17 : FDC
    port map (
      D => adder_n0006_16_cyo,
      CLR => buffer_data_01_14_N0,
      C => in_user_clk,
      Q => buffer_data_00_03(17)
    );
  adder_n0001_1_xor : XORCY
    port map (
      CI => adder_n0001_0_cyo,
      LI => N124,
      O => Q_n0001(1)
    );
  adder_n0002_10_cy : MUXCY
    port map (
      CI => adder_n0002_9_cyo,
      DI => buffer_data_04_05(10),
      S => N111,
      O => adder_n0002_10_cyo
    );
  adder_n0006_0_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(0),
      I1 => buffer_data_02_03(0),
      LO => N9
    );
  adder_n0006_0_cy : MUXCY
    port map (
      CI => NlwRenamedSig_OI_out_data(19),
      DI => buffer_data_00_01(0),
      S => N9,
      O => adder_n0006_0_cyo
    );
  adder_n0002_11_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(11),
      I1 => buffer_data_06_07(11),
      LO => N112
    );
  adder_n0006_1_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(1),
      I1 => buffer_data_02_03(1),
      LO => N10
    );
  adder_n0006_1_cy : MUXCY
    port map (
      CI => adder_n0006_0_cyo,
      DI => buffer_data_00_01(1),
      S => N10,
      O => adder_n0006_1_cyo
    );
  adder_n0006_1_xor : XORCY
    port map (
      CI => adder_n0006_0_cyo,
      LI => N10,
      O => Q_n0006(1)
    );
  adder_n0006_2_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(2),
      I1 => buffer_data_02_03(2),
      LO => N11
    );
  adder_n0006_2_cy : MUXCY
    port map (
      CI => adder_n0006_1_cyo,
      DI => buffer_data_00_01(2),
      S => N11,
      O => adder_n0006_2_cyo
    );
  adder_n0006_2_xor : XORCY
    port map (
      CI => adder_n0006_1_cyo,
      LI => N11,
      O => Q_n0006(2)
    );
  adder_n0006_3_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(3),
      I1 => buffer_data_02_03(3),
      LO => N12
    );
  adder_n0006_3_cy : MUXCY
    port map (
      CI => adder_n0006_2_cyo,
      DI => buffer_data_00_01(3),
      S => N12,
      O => adder_n0006_3_cyo
    );
  adder_n0006_3_xor : XORCY
    port map (
      CI => adder_n0006_2_cyo,
      LI => N12,
      O => Q_n0006(3)
    );
  adder_n0006_4_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(4),
      I1 => buffer_data_02_03(4),
      LO => N13
    );
  adder_n0006_4_cy : MUXCY
    port map (
      CI => adder_n0006_3_cyo,
      DI => buffer_data_00_01(4),
      S => N13,
      O => adder_n0006_4_cyo
    );
  adder_n0006_4_xor : XORCY
    port map (
      CI => adder_n0006_3_cyo,
      LI => N13,
      O => Q_n0006(4)
    );
  adder_n0006_5_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(5),
      I1 => buffer_data_02_03(5),
      LO => N14
    );
  adder_n0006_5_cy : MUXCY
    port map (
      CI => adder_n0006_4_cyo,
      DI => buffer_data_00_01(5),
      S => N14,
      O => adder_n0006_5_cyo
    );
  adder_n0006_5_xor : XORCY
    port map (
      CI => adder_n0006_4_cyo,
      LI => N14,
      O => Q_n0006(5)
    );
  adder_n0006_6_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(6),
      I1 => buffer_data_02_03(6),
      LO => N15
    );
  adder_n0006_6_cy : MUXCY
    port map (
      CI => adder_n0006_5_cyo,
      DI => buffer_data_00_01(6),
      S => N15,
      O => adder_n0006_6_cyo
    );
  adder_n0006_6_xor : XORCY
    port map (
      CI => adder_n0006_5_cyo,
      LI => N15,
      O => Q_n0006(6)
    );
  adder_n0006_7_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(7),
      I1 => buffer_data_02_03(7),
      LO => N16
    );
  adder_n0006_7_cy : MUXCY
    port map (
      CI => adder_n0006_6_cyo,
      DI => buffer_data_00_01(7),
      S => N16,
      O => adder_n0006_7_cyo
    );
  adder_n0006_7_xor : XORCY
    port map (
      CI => adder_n0006_6_cyo,
      LI => N16,
      O => Q_n0006(7)
    );
  adder_n0006_8_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(8),
      I1 => buffer_data_02_03(8),
      LO => N17
    );
  adder_n0006_8_cy : MUXCY
    port map (
      CI => adder_n0006_7_cyo,
      DI => buffer_data_00_01(8),
      S => N17,
      O => adder_n0006_8_cyo
    );
  adder_n0006_8_xor : XORCY
    port map (
      CI => adder_n0006_7_cyo,
      LI => N17,
      O => Q_n0006(8)
    );
  adder_n0006_9_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(9),
      I1 => buffer_data_02_03(9),
      LO => N18
    );
  adder_n0006_9_cy : MUXCY
    port map (
      CI => adder_n0006_8_cyo,
      DI => buffer_data_00_01(9),
      S => N18,
      O => adder_n0006_9_cyo
    );
  adder_n0006_9_xor : XORCY
    port map (
      CI => adder_n0006_8_cyo,
      LI => N18,
      O => Q_n0006(9)
    );
  adder_n0006_10_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(10),
      I1 => buffer_data_02_03(10),
      LO => N19
    );
  adder_n0006_10_cy : MUXCY
    port map (
      CI => adder_n0006_9_cyo,
      DI => buffer_data_00_01(10),
      S => N19,
      O => adder_n0006_10_cyo
    );
  adder_n0006_10_xor : XORCY
    port map (
      CI => adder_n0006_9_cyo,
      LI => N19,
      O => Q_n0006(10)
    );
  adder_n0006_11_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(11),
      I1 => buffer_data_02_03(11),
      LO => N20
    );
  adder_n0006_11_cy : MUXCY
    port map (
      CI => adder_n0006_10_cyo,
      DI => buffer_data_00_01(11),
      S => N20,
      O => adder_n0006_11_cyo
    );
  adder_n0006_11_xor : XORCY
    port map (
      CI => adder_n0006_10_cyo,
      LI => N20,
      O => Q_n0006(11)
    );
  adder_n0006_12_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(12),
      I1 => buffer_data_02_03(12),
      LO => N21
    );
  adder_n0006_12_cy : MUXCY
    port map (
      CI => adder_n0006_11_cyo,
      DI => buffer_data_00_01(12),
      S => N21,
      O => adder_n0006_12_cyo
    );
  adder_n0006_12_xor : XORCY
    port map (
      CI => adder_n0006_11_cyo,
      LI => N21,
      O => Q_n0006(12)
    );
  adder_n0006_13_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(13),
      I1 => buffer_data_02_03(13),
      LO => N22
    );
  adder_n0006_13_cy : MUXCY
    port map (
      CI => adder_n0006_12_cyo,
      DI => buffer_data_00_01(13),
      S => N22,
      O => adder_n0006_13_cyo
    );
  adder_n0006_13_xor : XORCY
    port map (
      CI => adder_n0006_12_cyo,
      LI => N22,
      O => Q_n0006(13)
    );
  adder_n0006_14_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(14),
      I1 => buffer_data_02_03(14),
      LO => N23
    );
  adder_n0006_14_cy : MUXCY
    port map (
      CI => adder_n0006_13_cyo,
      DI => buffer_data_00_01(14),
      S => N23,
      O => adder_n0006_14_cyo
    );
  adder_n0006_14_xor : XORCY
    port map (
      CI => adder_n0006_13_cyo,
      LI => N23,
      O => Q_n0006(14)
    );
  adder_n0006_15_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(15),
      I1 => buffer_data_02_03(15),
      LO => N24
    );
  adder_n0006_15_cy : MUXCY
    port map (
      CI => adder_n0006_14_cyo,
      DI => buffer_data_00_01(15),
      S => N24,
      O => adder_n0006_15_cyo
    );
  adder_n0006_15_xor : XORCY
    port map (
      CI => adder_n0006_14_cyo,
      LI => N24,
      O => Q_n0006(15)
    );
  adder_n0006_16_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_01(16),
      I1 => buffer_data_02_03(16),
      LO => N25
    );
  adder_n0006_16_cy : MUXCY
    port map (
      CI => adder_n0006_15_cyo,
      DI => buffer_data_00_01(16),
      S => N25,
      O => adder_n0006_16_cyo
    );
  adder_n0006_16_xor : XORCY
    port map (
      CI => adder_n0006_15_cyo,
      LI => N25,
      O => Q_n0006(16)
    );
  adder_n0001_1_cy : MUXCY
    port map (
      CI => adder_n0001_0_cyo,
      DI => buffer_data_04(1),
      S => N124,
      O => adder_n0001_1_cyo
    );
  adder_n0001_1_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(1),
      I1 => buffer_data_05(1),
      LO => N124
    );
  adder_n0002_10_xor : XORCY
    port map (
      CI => adder_n0002_9_cyo,
      LI => N111,
      O => Q_n0002(10)
    );
  adder_n0002_13_cy : MUXCY
    port map (
      CI => adder_n0002_12_cyo,
      DI => buffer_data_04_05(13),
      S => N114,
      O => adder_n0002_13_cyo
    );
  adder_n0001_0_cy : MUXCY
    port map (
      CI => NlwRenamedSig_OI_out_data(19),
      DI => buffer_data_04(0),
      S => N123,
      O => adder_n0001_0_cyo
    );
  adder_n0001_2_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(2),
      I1 => buffer_data_05(2),
      LO => N125
    );
  adder_n0001_0_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(0),
      I1 => buffer_data_05(0),
      LO => N123
    );
  adder_n0002_14_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(14),
      I1 => buffer_data_06_07(14),
      LO => N115
    );
  adder_n0001_4_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(4),
      I1 => buffer_data_05(4),
      LO => N127
    );
  adder_n0002_14_cy : MUXCY
    port map (
      CI => adder_n0002_13_cyo,
      DI => buffer_data_04_05(14),
      S => N115,
      O => adder_n0002_14_cyo
    );
  adder_n0001_6_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(6),
      I1 => buffer_data_05(6),
      LO => N129
    );
  adder_n0001_12_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(12),
      I1 => buffer_data_05(12),
      LO => N135
    );
  adder_n0002_14_xor : XORCY
    port map (
      CI => adder_n0002_13_cyo,
      LI => N115,
      O => Q_n0002(14)
    );
  adder_n0002_15_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(15),
      I1 => buffer_data_06_07(15),
      LO => N116
    );
  adder_n0005_0_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(0),
      I1 => buffer_data_01(0),
      LO => N31
    );
  adder_n0005_0_cy : MUXCY
    port map (
      CI => NlwRenamedSig_OI_out_data(19),
      DI => buffer_data_00(0),
      S => N31,
      O => adder_n0005_0_cyo
    );
  adder_n0002_11_cy : MUXCY
    port map (
      CI => adder_n0002_10_cyo,
      DI => buffer_data_04_05(11),
      S => N112,
      O => adder_n0002_11_cyo
    );
  adder_n0005_1_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(1),
      I1 => buffer_data_01(1),
      LO => N32
    );
  adder_n0005_1_cy : MUXCY
    port map (
      CI => adder_n0005_0_cyo,
      DI => buffer_data_00(1),
      S => N32,
      O => adder_n0005_1_cyo
    );
  adder_n0005_1_xor : XORCY
    port map (
      CI => adder_n0005_0_cyo,
      LI => N32,
      O => Q_n0005(1)
    );
  adder_n0005_2_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(2),
      I1 => buffer_data_01(2),
      LO => N33
    );
  adder_n0005_2_cy : MUXCY
    port map (
      CI => adder_n0005_1_cyo,
      DI => buffer_data_00(2),
      S => N33,
      O => adder_n0005_2_cyo
    );
  adder_n0005_2_xor : XORCY
    port map (
      CI => adder_n0005_1_cyo,
      LI => N33,
      O => Q_n0005(2)
    );
  adder_n0005_3_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(3),
      I1 => buffer_data_01(3),
      LO => N34
    );
  adder_n0005_3_cy : MUXCY
    port map (
      CI => adder_n0005_2_cyo,
      DI => buffer_data_00(3),
      S => N34,
      O => adder_n0005_3_cyo
    );
  adder_n0005_3_xor : XORCY
    port map (
      CI => adder_n0005_2_cyo,
      LI => N34,
      O => Q_n0005(3)
    );
  adder_n0005_4_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(4),
      I1 => buffer_data_01(4),
      LO => N35
    );
  adder_n0005_4_cy : MUXCY
    port map (
      CI => adder_n0005_3_cyo,
      DI => buffer_data_00(4),
      S => N35,
      O => adder_n0005_4_cyo
    );
  adder_n0005_4_xor : XORCY
    port map (
      CI => adder_n0005_3_cyo,
      LI => N35,
      O => Q_n0005(4)
    );
  adder_n0005_5_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(5),
      I1 => buffer_data_01(5),
      LO => N36
    );
  adder_n0005_5_cy : MUXCY
    port map (
      CI => adder_n0005_4_cyo,
      DI => buffer_data_00(5),
      S => N36,
      O => adder_n0005_5_cyo
    );
  adder_n0005_5_xor : XORCY
    port map (
      CI => adder_n0005_4_cyo,
      LI => N36,
      O => Q_n0005(5)
    );
  adder_n0005_6_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(6),
      I1 => buffer_data_01(6),
      LO => N37
    );
  adder_n0005_6_cy : MUXCY
    port map (
      CI => adder_n0005_5_cyo,
      DI => buffer_data_00(6),
      S => N37,
      O => adder_n0005_6_cyo
    );
  adder_n0005_6_xor : XORCY
    port map (
      CI => adder_n0005_5_cyo,
      LI => N37,
      O => Q_n0005(6)
    );
  adder_n0005_7_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(7),
      I1 => buffer_data_01(7),
      LO => N38
    );
  adder_n0005_7_cy : MUXCY
    port map (
      CI => adder_n0005_6_cyo,
      DI => buffer_data_00(7),
      S => N38,
      O => adder_n0005_7_cyo
    );
  adder_n0005_7_xor : XORCY
    port map (
      CI => adder_n0005_6_cyo,
      LI => N38,
      O => Q_n0005(7)
    );
  adder_n0005_8_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(8),
      I1 => buffer_data_01(8),
      LO => N39
    );
  adder_n0005_8_cy : MUXCY
    port map (
      CI => adder_n0005_7_cyo,
      DI => buffer_data_00(8),
      S => N39,
      O => adder_n0005_8_cyo
    );
  adder_n0005_8_xor : XORCY
    port map (
      CI => adder_n0005_7_cyo,
      LI => N39,
      O => Q_n0005(8)
    );
  adder_n0005_9_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(9),
      I1 => buffer_data_01(9),
      LO => N40
    );
  adder_n0005_9_cy : MUXCY
    port map (
      CI => adder_n0005_8_cyo,
      DI => buffer_data_00(9),
      S => N40,
      O => adder_n0005_9_cyo
    );
  adder_n0005_9_xor : XORCY
    port map (
      CI => adder_n0005_8_cyo,
      LI => N40,
      O => Q_n0005(9)
    );
  adder_n0005_10_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(10),
      I1 => buffer_data_01(10),
      LO => N41
    );
  adder_n0005_10_cy : MUXCY
    port map (
      CI => adder_n0005_9_cyo,
      DI => buffer_data_00(10),
      S => N41,
      O => adder_n0005_10_cyo
    );
  adder_n0005_10_xor : XORCY
    port map (
      CI => adder_n0005_9_cyo,
      LI => N41,
      O => Q_n0005(10)
    );
  adder_n0005_11_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(11),
      I1 => buffer_data_01(11),
      LO => N42
    );
  adder_n0005_11_cy : MUXCY
    port map (
      CI => adder_n0005_10_cyo,
      DI => buffer_data_00(11),
      S => N42,
      O => adder_n0005_11_cyo
    );
  adder_n0005_11_xor : XORCY
    port map (
      CI => adder_n0005_10_cyo,
      LI => N42,
      O => Q_n0005(11)
    );
  adder_n0005_12_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(12),
      I1 => buffer_data_01(12),
      LO => N43
    );
  adder_n0005_12_cy : MUXCY
    port map (
      CI => adder_n0005_11_cyo,
      DI => buffer_data_00(12),
      S => N43,
      O => adder_n0005_12_cyo
    );
  adder_n0005_12_xor : XORCY
    port map (
      CI => adder_n0005_11_cyo,
      LI => N43,
      O => Q_n0005(12)
    );
  adder_n0005_13_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(13),
      I1 => buffer_data_01(13),
      LO => N44
    );
  adder_n0005_13_cy : MUXCY
    port map (
      CI => adder_n0005_12_cyo,
      DI => buffer_data_00(13),
      S => N44,
      O => adder_n0005_13_cyo
    );
  adder_n0005_13_xor : XORCY
    port map (
      CI => adder_n0005_12_cyo,
      LI => N44,
      O => Q_n0005(13)
    );
  adder_n0005_14_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(14),
      I1 => buffer_data_01(14),
      LO => N45
    );
  adder_n0005_14_cy : MUXCY
    port map (
      CI => adder_n0005_13_cyo,
      DI => buffer_data_00(14),
      S => N45,
      O => adder_n0005_14_cyo
    );
  adder_n0005_14_xor : XORCY
    port map (
      CI => adder_n0005_13_cyo,
      LI => N45,
      O => Q_n0005(14)
    );
  adder_n0005_15_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00(15),
      I1 => buffer_data_01(15),
      LO => N46
    );
  adder_n0005_15_cy : MUXCY
    port map (
      CI => adder_n0005_14_cyo,
      DI => buffer_data_00(15),
      S => N46,
      O => adder_n0005_15_cyo
    );
  adder_n0004_0_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(0),
      I1 => buffer_data_04_07(0),
      LO => N47
    );
  adder_n0004_0_cy : MUXCY
    port map (
      CI => NlwRenamedSig_OI_out_data(19),
      DI => buffer_data_00_03(0),
      S => N47,
      O => adder_n0004_0_cyo
    );
  adder_n0002_12_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(12),
      I1 => buffer_data_06_07(12),
      LO => N113
    );
  adder_n0004_1_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(1),
      I1 => buffer_data_04_07(1),
      LO => N48
    );
  adder_n0004_1_cy : MUXCY
    port map (
      CI => adder_n0004_0_cyo,
      DI => buffer_data_00_03(1),
      S => N48,
      O => adder_n0004_1_cyo
    );
  adder_n0004_1_xor : XORCY
    port map (
      CI => adder_n0004_0_cyo,
      LI => N48,
      O => Q_n0004(1)
    );
  adder_n0004_2_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(2),
      I1 => buffer_data_04_07(2),
      LO => N49
    );
  adder_n0004_2_cy : MUXCY
    port map (
      CI => adder_n0004_1_cyo,
      DI => buffer_data_00_03(2),
      S => N49,
      O => adder_n0004_2_cyo
    );
  adder_n0004_2_xor : XORCY
    port map (
      CI => adder_n0004_1_cyo,
      LI => N49,
      O => Q_n0004(2)
    );
  adder_n0004_3_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(3),
      I1 => buffer_data_04_07(3),
      LO => N50
    );
  adder_n0004_3_cy : MUXCY
    port map (
      CI => adder_n0004_2_cyo,
      DI => buffer_data_00_03(3),
      S => N50,
      O => adder_n0004_3_cyo
    );
  adder_n0004_3_xor : XORCY
    port map (
      CI => adder_n0004_2_cyo,
      LI => N50,
      O => Q_n0004(3)
    );
  adder_n0004_4_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(4),
      I1 => buffer_data_04_07(4),
      LO => N51
    );
  adder_n0004_4_cy : MUXCY
    port map (
      CI => adder_n0004_3_cyo,
      DI => buffer_data_00_03(4),
      S => N51,
      O => adder_n0004_4_cyo
    );
  adder_n0004_4_xor : XORCY
    port map (
      CI => adder_n0004_3_cyo,
      LI => N51,
      O => Q_n0004(4)
    );
  adder_n0004_5_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(5),
      I1 => buffer_data_04_07(5),
      LO => N52
    );
  adder_n0004_5_cy : MUXCY
    port map (
      CI => adder_n0004_4_cyo,
      DI => buffer_data_00_03(5),
      S => N52,
      O => adder_n0004_5_cyo
    );
  adder_n0004_5_xor : XORCY
    port map (
      CI => adder_n0004_4_cyo,
      LI => N52,
      O => Q_n0004(5)
    );
  adder_n0004_6_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(6),
      I1 => buffer_data_04_07(6),
      LO => N53
    );
  adder_n0004_6_cy : MUXCY
    port map (
      CI => adder_n0004_5_cyo,
      DI => buffer_data_00_03(6),
      S => N53,
      O => adder_n0004_6_cyo
    );
  adder_n0004_6_xor : XORCY
    port map (
      CI => adder_n0004_5_cyo,
      LI => N53,
      O => Q_n0004(6)
    );
  adder_n0004_7_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(7),
      I1 => buffer_data_04_07(7),
      LO => N54
    );
  adder_n0004_7_cy : MUXCY
    port map (
      CI => adder_n0004_6_cyo,
      DI => buffer_data_00_03(7),
      S => N54,
      O => adder_n0004_7_cyo
    );
  adder_n0004_7_xor : XORCY
    port map (
      CI => adder_n0004_6_cyo,
      LI => N54,
      O => Q_n0004(7)
    );
  adder_n0004_8_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(8),
      I1 => buffer_data_04_07(8),
      LO => N55
    );
  adder_n0004_8_cy : MUXCY
    port map (
      CI => adder_n0004_7_cyo,
      DI => buffer_data_00_03(8),
      S => N55,
      O => adder_n0004_8_cyo
    );
  adder_n0004_8_xor : XORCY
    port map (
      CI => adder_n0004_7_cyo,
      LI => N55,
      O => Q_n0004(8)
    );
  adder_n0004_9_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(9),
      I1 => buffer_data_04_07(9),
      LO => N56
    );
  adder_n0004_9_cy : MUXCY
    port map (
      CI => adder_n0004_8_cyo,
      DI => buffer_data_00_03(9),
      S => N56,
      O => adder_n0004_9_cyo
    );
  adder_n0004_9_xor : XORCY
    port map (
      CI => adder_n0004_8_cyo,
      LI => N56,
      O => Q_n0004(9)
    );
  adder_n0004_10_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(10),
      I1 => buffer_data_04_07(10),
      LO => N57
    );
  adder_n0004_10_cy : MUXCY
    port map (
      CI => adder_n0004_9_cyo,
      DI => buffer_data_00_03(10),
      S => N57,
      O => adder_n0004_10_cyo
    );
  adder_n0004_10_xor : XORCY
    port map (
      CI => adder_n0004_9_cyo,
      LI => N57,
      O => Q_n0004(10)
    );
  adder_n0004_11_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(11),
      I1 => buffer_data_04_07(11),
      LO => N58
    );
  adder_n0004_11_cy : MUXCY
    port map (
      CI => adder_n0004_10_cyo,
      DI => buffer_data_00_03(11),
      S => N58,
      O => adder_n0004_11_cyo
    );
  adder_n0004_11_xor : XORCY
    port map (
      CI => adder_n0004_10_cyo,
      LI => N58,
      O => Q_n0004(11)
    );
  adder_n0004_12_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(12),
      I1 => buffer_data_04_07(12),
      LO => N59
    );
  adder_n0004_12_cy : MUXCY
    port map (
      CI => adder_n0004_11_cyo,
      DI => buffer_data_00_03(12),
      S => N59,
      O => adder_n0004_12_cyo
    );
  adder_n0004_12_xor : XORCY
    port map (
      CI => adder_n0004_11_cyo,
      LI => N59,
      O => Q_n0004(12)
    );
  adder_n0004_13_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(13),
      I1 => buffer_data_04_07(13),
      LO => N60
    );
  adder_n0004_13_cy : MUXCY
    port map (
      CI => adder_n0004_12_cyo,
      DI => buffer_data_00_03(13),
      S => N60,
      O => adder_n0004_13_cyo
    );
  adder_n0004_13_xor : XORCY
    port map (
      CI => adder_n0004_12_cyo,
      LI => N60,
      O => Q_n0004(13)
    );
  adder_n0004_14_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(14),
      I1 => buffer_data_04_07(14),
      LO => N61
    );
  adder_n0004_14_cy : MUXCY
    port map (
      CI => adder_n0004_13_cyo,
      DI => buffer_data_00_03(14),
      S => N61,
      O => adder_n0004_14_cyo
    );
  adder_n0004_14_xor : XORCY
    port map (
      CI => adder_n0004_13_cyo,
      LI => N61,
      O => Q_n0004(14)
    );
  adder_n0004_15_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(15),
      I1 => buffer_data_04_07(15),
      LO => N62
    );
  adder_n0004_15_cy : MUXCY
    port map (
      CI => adder_n0004_14_cyo,
      DI => buffer_data_00_03(15),
      S => N62,
      O => adder_n0004_15_cyo
    );
  adder_n0004_15_xor : XORCY
    port map (
      CI => adder_n0004_14_cyo,
      LI => N62,
      O => Q_n0004(15)
    );
  adder_n0004_16_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(16),
      I1 => buffer_data_04_07(16),
      LO => N63
    );
  adder_n0004_16_cy : MUXCY
    port map (
      CI => adder_n0004_15_cyo,
      DI => buffer_data_00_03(16),
      S => N63,
      O => adder_n0004_16_cyo
    );
  adder_n0004_16_xor : XORCY
    port map (
      CI => adder_n0004_15_cyo,
      LI => N63,
      O => Q_n0004(16)
    );
  adder_n0004_17_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_00_03(17),
      I1 => buffer_data_04_07(17),
      LO => N64
    );
  adder_n0004_17_cy : MUXCY
    port map (
      CI => adder_n0004_16_cyo,
      DI => buffer_data_00_03(17),
      S => N64,
      O => adder_n0004_17_cyo
    );
  adder_n0004_17_xor : XORCY
    port map (
      CI => adder_n0004_16_cyo,
      LI => N64,
      O => Q_n0004(17)
    );
  adder_n0001_6_xor : XORCY
    port map (
      CI => adder_n0001_5_cyo,
      LI => N129,
      O => Q_n0001(6)
    );
  adder_n0002_15_cy : MUXCY
    port map (
      CI => adder_n0002_14_cyo,
      DI => buffer_data_04_05(15),
      S => N116,
      O => adder_n0002_15_cyo
    );
  adder_n0002_11_xor : XORCY
    port map (
      CI => adder_n0002_10_cyo,
      LI => N112,
      O => Q_n0002(11)
    );
  adder_n0002_15_xor : XORCY
    port map (
      CI => adder_n0002_14_cyo,
      LI => N116,
      O => Q_n0002(15)
    );
  adder_n0001_7_cy : MUXCY
    port map (
      CI => adder_n0001_6_cyo,
      DI => buffer_data_04(7),
      S => N130,
      O => adder_n0001_7_cyo
    );
  adder_n0001_10_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04(10),
      I1 => buffer_data_05(10),
      LO => N133
    );
  adder_n0002_16_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(16),
      I1 => buffer_data_06_07(16),
      LO => N117
    );
  adder_n0002_16_cy : MUXCY
    port map (
      CI => adder_n0002_15_cyo,
      DI => buffer_data_04_05(16),
      S => N117,
      O => adder_n0002_16_cyo
    );
  adder_n0001_9_cy : MUXCY
    port map (
      CI => adder_n0001_8_cyo,
      DI => buffer_data_04(9),
      S => N132,
      O => adder_n0001_9_cyo
    );
  adder_n0002_12_xor : XORCY
    port map (
      CI => adder_n0002_11_cyo,
      LI => N113,
      O => Q_n0002(12)
    );
  adder_n0002_16_xor : XORCY
    port map (
      CI => adder_n0002_15_cyo,
      LI => N117,
      O => Q_n0002(16)
    );
  adder_n0003_0_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(0),
      I1 => buffer_data_07(0),
      LO => N69
    );
  adder_n0003_0_cy : MUXCY
    port map (
      CI => NlwRenamedSig_OI_out_data(19),
      DI => buffer_data_06(0),
      S => N69,
      O => adder_n0003_0_cyo
    );
  adder_n0002_12_cy : MUXCY
    port map (
      CI => adder_n0002_11_cyo,
      DI => buffer_data_04_05(12),
      S => N113,
      O => adder_n0002_12_cyo
    );
  adder_n0003_1_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(1),
      I1 => buffer_data_07(1),
      LO => N70
    );
  adder_n0003_1_cy : MUXCY
    port map (
      CI => adder_n0003_0_cyo,
      DI => buffer_data_06(1),
      S => N70,
      O => adder_n0003_1_cyo
    );
  adder_n0003_1_xor : XORCY
    port map (
      CI => adder_n0003_0_cyo,
      LI => N70,
      O => Q_n0003(1)
    );
  adder_n0003_2_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(2),
      I1 => buffer_data_07(2),
      LO => N71
    );
  adder_n0003_2_cy : MUXCY
    port map (
      CI => adder_n0003_1_cyo,
      DI => buffer_data_06(2),
      S => N71,
      O => adder_n0003_2_cyo
    );
  adder_n0003_2_xor : XORCY
    port map (
      CI => adder_n0003_1_cyo,
      LI => N71,
      O => Q_n0003(2)
    );
  adder_n0003_3_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(3),
      I1 => buffer_data_07(3),
      LO => N72
    );
  adder_n0003_3_cy : MUXCY
    port map (
      CI => adder_n0003_2_cyo,
      DI => buffer_data_06(3),
      S => N72,
      O => adder_n0003_3_cyo
    );
  adder_n0003_3_xor : XORCY
    port map (
      CI => adder_n0003_2_cyo,
      LI => N72,
      O => Q_n0003(3)
    );
  adder_n0003_4_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(4),
      I1 => buffer_data_07(4),
      LO => N73
    );
  adder_n0003_4_cy : MUXCY
    port map (
      CI => adder_n0003_3_cyo,
      DI => buffer_data_06(4),
      S => N73,
      O => adder_n0003_4_cyo
    );
  adder_n0003_4_xor : XORCY
    port map (
      CI => adder_n0003_3_cyo,
      LI => N73,
      O => Q_n0003(4)
    );
  adder_n0003_5_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(5),
      I1 => buffer_data_07(5),
      LO => N74
    );
  adder_n0003_5_cy : MUXCY
    port map (
      CI => adder_n0003_4_cyo,
      DI => buffer_data_06(5),
      S => N74,
      O => adder_n0003_5_cyo
    );
  adder_n0003_5_xor : XORCY
    port map (
      CI => adder_n0003_4_cyo,
      LI => N74,
      O => Q_n0003(5)
    );
  adder_n0003_6_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(6),
      I1 => buffer_data_07(6),
      LO => N75
    );
  adder_n0003_6_cy : MUXCY
    port map (
      CI => adder_n0003_5_cyo,
      DI => buffer_data_06(6),
      S => N75,
      O => adder_n0003_6_cyo
    );
  adder_n0003_6_xor : XORCY
    port map (
      CI => adder_n0003_5_cyo,
      LI => N75,
      O => Q_n0003(6)
    );
  adder_n0003_7_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(7),
      I1 => buffer_data_07(7),
      LO => N76
    );
  adder_n0003_7_cy : MUXCY
    port map (
      CI => adder_n0003_6_cyo,
      DI => buffer_data_06(7),
      S => N76,
      O => adder_n0003_7_cyo
    );
  adder_n0003_7_xor : XORCY
    port map (
      CI => adder_n0003_6_cyo,
      LI => N76,
      O => Q_n0003(7)
    );
  adder_n0003_8_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(8),
      I1 => buffer_data_07(8),
      LO => N77
    );
  adder_n0003_8_cy : MUXCY
    port map (
      CI => adder_n0003_7_cyo,
      DI => buffer_data_06(8),
      S => N77,
      O => adder_n0003_8_cyo
    );
  adder_n0003_8_xor : XORCY
    port map (
      CI => adder_n0003_7_cyo,
      LI => N77,
      O => Q_n0003(8)
    );
  adder_n0003_9_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(9),
      I1 => buffer_data_07(9),
      LO => N78
    );
  adder_n0003_9_cy : MUXCY
    port map (
      CI => adder_n0003_8_cyo,
      DI => buffer_data_06(9),
      S => N78,
      O => adder_n0003_9_cyo
    );
  adder_n0003_9_xor : XORCY
    port map (
      CI => adder_n0003_8_cyo,
      LI => N78,
      O => Q_n0003(9)
    );
  adder_n0003_10_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(10),
      I1 => buffer_data_07(10),
      LO => N79
    );
  adder_n0003_10_cy : MUXCY
    port map (
      CI => adder_n0003_9_cyo,
      DI => buffer_data_06(10),
      S => N79,
      O => adder_n0003_10_cyo
    );
  adder_n0003_10_xor : XORCY
    port map (
      CI => adder_n0003_9_cyo,
      LI => N79,
      O => Q_n0003(10)
    );
  adder_n0003_11_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(11),
      I1 => buffer_data_07(11),
      LO => N80
    );
  adder_n0003_11_cy : MUXCY
    port map (
      CI => adder_n0003_10_cyo,
      DI => buffer_data_06(11),
      S => N80,
      O => adder_n0003_11_cyo
    );
  adder_n0003_11_xor : XORCY
    port map (
      CI => adder_n0003_10_cyo,
      LI => N80,
      O => Q_n0003(11)
    );
  adder_n0003_12_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(12),
      I1 => buffer_data_07(12),
      LO => N81
    );
  adder_n0003_12_cy : MUXCY
    port map (
      CI => adder_n0003_11_cyo,
      DI => buffer_data_06(12),
      S => N81,
      O => adder_n0003_12_cyo
    );
  adder_n0003_12_xor : XORCY
    port map (
      CI => adder_n0003_11_cyo,
      LI => N81,
      O => Q_n0003(12)
    );
  adder_n0003_13_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(13),
      I1 => buffer_data_07(13),
      LO => N82
    );
  adder_n0003_13_cy : MUXCY
    port map (
      CI => adder_n0003_12_cyo,
      DI => buffer_data_06(13),
      S => N82,
      O => adder_n0003_13_cyo
    );
  adder_n0003_13_xor : XORCY
    port map (
      CI => adder_n0003_12_cyo,
      LI => N82,
      O => Q_n0003(13)
    );
  adder_n0003_14_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(14),
      I1 => buffer_data_07(14),
      LO => N83
    );
  adder_n0003_14_cy : MUXCY
    port map (
      CI => adder_n0003_13_cyo,
      DI => buffer_data_06(14),
      S => N83,
      O => adder_n0003_14_cyo
    );
  adder_n0003_14_xor : XORCY
    port map (
      CI => adder_n0003_13_cyo,
      LI => N83,
      O => Q_n0003(14)
    );
  adder_n0003_15_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_06(15),
      I1 => buffer_data_07(15),
      LO => N84
    );
  adder_n0003_15_cy : MUXCY
    port map (
      CI => adder_n0003_14_cyo,
      DI => buffer_data_06(15),
      S => N84,
      O => adder_n0003_15_cyo
    );
  adder_n0000_0_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(0),
      I1 => buffer_data_03(0),
      LO => N85
    );
  adder_n0000_0_cy : MUXCY
    port map (
      CI => NlwRenamedSig_OI_out_data(19),
      DI => buffer_data_02(0),
      S => N85,
      O => adder_n0000_0_cyo
    );
  adder_n0002_13_xor : XORCY
    port map (
      CI => adder_n0002_12_cyo,
      LI => N114,
      O => Q_n0002(13)
    );
  adder_n0000_1_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(1),
      I1 => buffer_data_03(1),
      LO => N86
    );
  adder_n0000_1_cy : MUXCY
    port map (
      CI => adder_n0000_0_cyo,
      DI => buffer_data_02(1),
      S => N86,
      O => adder_n0000_1_cyo
    );
  adder_n0000_1_xor : XORCY
    port map (
      CI => adder_n0000_0_cyo,
      LI => N86,
      O => Q_n0000(1)
    );
  adder_n0000_2_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(2),
      I1 => buffer_data_03(2),
      LO => N87
    );
  adder_n0000_2_cy : MUXCY
    port map (
      CI => adder_n0000_1_cyo,
      DI => buffer_data_02(2),
      S => N87,
      O => adder_n0000_2_cyo
    );
  adder_n0000_2_xor : XORCY
    port map (
      CI => adder_n0000_1_cyo,
      LI => N87,
      O => Q_n0000(2)
    );
  adder_n0000_3_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(3),
      I1 => buffer_data_03(3),
      LO => N88
    );
  adder_n0000_3_cy : MUXCY
    port map (
      CI => adder_n0000_2_cyo,
      DI => buffer_data_02(3),
      S => N88,
      O => adder_n0000_3_cyo
    );
  adder_n0000_3_xor : XORCY
    port map (
      CI => adder_n0000_2_cyo,
      LI => N88,
      O => Q_n0000(3)
    );
  adder_n0000_4_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(4),
      I1 => buffer_data_03(4),
      LO => N89
    );
  adder_n0000_4_cy : MUXCY
    port map (
      CI => adder_n0000_3_cyo,
      DI => buffer_data_02(4),
      S => N89,
      O => adder_n0000_4_cyo
    );
  adder_n0000_4_xor : XORCY
    port map (
      CI => adder_n0000_3_cyo,
      LI => N89,
      O => Q_n0000(4)
    );
  adder_n0000_5_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(5),
      I1 => buffer_data_03(5),
      LO => N90
    );
  adder_n0000_5_cy : MUXCY
    port map (
      CI => adder_n0000_4_cyo,
      DI => buffer_data_02(5),
      S => N90,
      O => adder_n0000_5_cyo
    );
  adder_n0000_5_xor : XORCY
    port map (
      CI => adder_n0000_4_cyo,
      LI => N90,
      O => Q_n0000(5)
    );
  adder_n0000_6_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(6),
      I1 => buffer_data_03(6),
      LO => N91
    );
  adder_n0000_6_cy : MUXCY
    port map (
      CI => adder_n0000_5_cyo,
      DI => buffer_data_02(6),
      S => N91,
      O => adder_n0000_6_cyo
    );
  adder_n0000_6_xor : XORCY
    port map (
      CI => adder_n0000_5_cyo,
      LI => N91,
      O => Q_n0000(6)
    );
  adder_n0000_7_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(7),
      I1 => buffer_data_03(7),
      LO => N92
    );
  adder_n0000_7_cy : MUXCY
    port map (
      CI => adder_n0000_6_cyo,
      DI => buffer_data_02(7),
      S => N92,
      O => adder_n0000_7_cyo
    );
  adder_n0000_7_xor : XORCY
    port map (
      CI => adder_n0000_6_cyo,
      LI => N92,
      O => Q_n0000(7)
    );
  adder_n0000_8_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(8),
      I1 => buffer_data_03(8),
      LO => N93
    );
  adder_n0000_8_cy : MUXCY
    port map (
      CI => adder_n0000_7_cyo,
      DI => buffer_data_02(8),
      S => N93,
      O => adder_n0000_8_cyo
    );
  adder_n0000_8_xor : XORCY
    port map (
      CI => adder_n0000_7_cyo,
      LI => N93,
      O => Q_n0000(8)
    );
  adder_n0000_9_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(9),
      I1 => buffer_data_03(9),
      LO => N94
    );
  adder_n0000_9_cy : MUXCY
    port map (
      CI => adder_n0000_8_cyo,
      DI => buffer_data_02(9),
      S => N94,
      O => adder_n0000_9_cyo
    );
  adder_n0000_9_xor : XORCY
    port map (
      CI => adder_n0000_8_cyo,
      LI => N94,
      O => Q_n0000(9)
    );
  adder_n0000_10_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(10),
      I1 => buffer_data_03(10),
      LO => N95
    );
  adder_n0000_10_cy : MUXCY
    port map (
      CI => adder_n0000_9_cyo,
      DI => buffer_data_02(10),
      S => N95,
      O => adder_n0000_10_cyo
    );
  adder_n0000_10_xor : XORCY
    port map (
      CI => adder_n0000_9_cyo,
      LI => N95,
      O => Q_n0000(10)
    );
  adder_n0000_11_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(11),
      I1 => buffer_data_03(11),
      LO => N96
    );
  adder_n0000_11_cy : MUXCY
    port map (
      CI => adder_n0000_10_cyo,
      DI => buffer_data_02(11),
      S => N96,
      O => adder_n0000_11_cyo
    );
  adder_n0000_11_xor : XORCY
    port map (
      CI => adder_n0000_10_cyo,
      LI => N96,
      O => Q_n0000(11)
    );
  adder_n0000_12_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(12),
      I1 => buffer_data_03(12),
      LO => N97
    );
  adder_n0000_12_cy : MUXCY
    port map (
      CI => adder_n0000_11_cyo,
      DI => buffer_data_02(12),
      S => N97,
      O => adder_n0000_12_cyo
    );
  adder_n0000_12_xor : XORCY
    port map (
      CI => adder_n0000_11_cyo,
      LI => N97,
      O => Q_n0000(12)
    );
  adder_n0000_13_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(13),
      I1 => buffer_data_03(13),
      LO => N98
    );
  adder_n0000_13_cy : MUXCY
    port map (
      CI => adder_n0000_12_cyo,
      DI => buffer_data_02(13),
      S => N98,
      O => adder_n0000_13_cyo
    );
  adder_n0000_13_xor : XORCY
    port map (
      CI => adder_n0000_12_cyo,
      LI => N98,
      O => Q_n0000(13)
    );
  adder_n0000_14_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(14),
      I1 => buffer_data_03(14),
      LO => N99
    );
  adder_n0000_14_cy : MUXCY
    port map (
      CI => adder_n0000_13_cyo,
      DI => buffer_data_02(14),
      S => N99,
      O => adder_n0000_14_cyo
    );
  adder_n0000_14_xor : XORCY
    port map (
      CI => adder_n0000_13_cyo,
      LI => N99,
      O => Q_n0000(14)
    );
  adder_n0000_15_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_02(15),
      I1 => buffer_data_03(15),
      LO => N100
    );
  adder_n0000_15_cy : MUXCY
    port map (
      CI => adder_n0000_14_cyo,
      DI => buffer_data_02(15),
      S => N100,
      O => adder_n0000_15_cyo
    );
  adder_n0002_0_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(0),
      I1 => buffer_data_06_07(0),
      LO => N101
    );
  adder_n0002_0_cy : MUXCY
    port map (
      CI => NlwRenamedSig_OI_out_data(19),
      DI => buffer_data_04_05(0),
      S => N101,
      O => adder_n0002_0_cyo
    );
  adder_n0002_13_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(13),
      I1 => buffer_data_06_07(13),
      LO => N114
    );
  adder_n0002_1_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(1),
      I1 => buffer_data_06_07(1),
      LO => N102
    );
  adder_n0002_1_cy : MUXCY
    port map (
      CI => adder_n0002_0_cyo,
      DI => buffer_data_04_05(1),
      S => N102,
      O => adder_n0002_1_cyo
    );
  adder_n0002_1_xor : XORCY
    port map (
      CI => adder_n0002_0_cyo,
      LI => N102,
      O => Q_n0002(1)
    );
  adder_n0002_2_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(2),
      I1 => buffer_data_06_07(2),
      LO => N103
    );
  adder_n0002_2_cy : MUXCY
    port map (
      CI => adder_n0002_1_cyo,
      DI => buffer_data_04_05(2),
      S => N103,
      O => adder_n0002_2_cyo
    );
  adder_n0002_2_xor : XORCY
    port map (
      CI => adder_n0002_1_cyo,
      LI => N103,
      O => Q_n0002(2)
    );
  adder_n0002_3_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(3),
      I1 => buffer_data_06_07(3),
      LO => N104
    );
  adder_n0002_3_cy : MUXCY
    port map (
      CI => adder_n0002_2_cyo,
      DI => buffer_data_04_05(3),
      S => N104,
      O => adder_n0002_3_cyo
    );
  adder_n0002_3_xor : XORCY
    port map (
      CI => adder_n0002_2_cyo,
      LI => N104,
      O => Q_n0002(3)
    );
  adder_n0002_4_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(4),
      I1 => buffer_data_06_07(4),
      LO => N105
    );
  adder_n0002_4_cy : MUXCY
    port map (
      CI => adder_n0002_3_cyo,
      DI => buffer_data_04_05(4),
      S => N105,
      O => adder_n0002_4_cyo
    );
  adder_n0002_4_xor : XORCY
    port map (
      CI => adder_n0002_3_cyo,
      LI => N105,
      O => Q_n0002(4)
    );
  adder_n0002_5_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(5),
      I1 => buffer_data_06_07(5),
      LO => N106
    );
  adder_n0002_5_cy : MUXCY
    port map (
      CI => adder_n0002_4_cyo,
      DI => buffer_data_04_05(5),
      S => N106,
      O => adder_n0002_5_cyo
    );
  adder_n0002_5_xor : XORCY
    port map (
      CI => adder_n0002_4_cyo,
      LI => N106,
      O => Q_n0002(5)
    );
  adder_n0002_6_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(6),
      I1 => buffer_data_06_07(6),
      LO => N107
    );
  adder_n0002_6_cy : MUXCY
    port map (
      CI => adder_n0002_5_cyo,
      DI => buffer_data_04_05(6),
      S => N107,
      O => adder_n0002_6_cyo
    );
  adder_n0002_6_xor : XORCY
    port map (
      CI => adder_n0002_5_cyo,
      LI => N107,
      O => Q_n0002(6)
    );
  adder_n0002_7_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(7),
      I1 => buffer_data_06_07(7),
      LO => N108
    );
  adder_n0002_7_cy : MUXCY
    port map (
      CI => adder_n0002_6_cyo,
      DI => buffer_data_04_05(7),
      S => N108,
      O => adder_n0002_7_cyo
    );
  adder_n0002_7_xor : XORCY
    port map (
      CI => adder_n0002_6_cyo,
      LI => N108,
      O => Q_n0002(7)
    );
  adder_n0002_8_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(8),
      I1 => buffer_data_06_07(8),
      LO => N109
    );
  adder_n0002_8_cy : MUXCY
    port map (
      CI => adder_n0002_7_cyo,
      DI => buffer_data_04_05(8),
      S => N109,
      O => adder_n0002_8_cyo
    );
  adder_n0002_8_xor : XORCY
    port map (
      CI => adder_n0002_7_cyo,
      LI => N109,
      O => Q_n0002(8)
    );
  adder_n0002_9_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(9),
      I1 => buffer_data_06_07(9),
      LO => N110
    );
  adder_n0002_9_cy : MUXCY
    port map (
      CI => adder_n0002_8_cyo,
      DI => buffer_data_04_05(9),
      S => N110,
      O => adder_n0002_9_cyo
    );
  adder_n0002_9_xor : XORCY
    port map (
      CI => adder_n0002_8_cyo,
      LI => N110,
      O => Q_n0002(9)
    );
  adder_n0002_10_lut : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => buffer_data_04_05(10),
      I1 => buffer_data_06_07(10),
      LO => N111
    );

end Structure;

