--------------------------------------------------------------------------------
-- Copyright (c) 1995-2005 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version: H.42
--  \   \         Application: netgen
--  /   /         Filename: memphy_synthesis.vhd
-- /___/   /\     Timestamp: Tue Jul 04 15:44:22 2006
-- \   \  /  \ 
--  \___\/\___\
--             
-- Command	: -intstyle ise -ar Structure -w -ofmt vhdl -sim memphy.ngc memphy_synthesis.vhd 
-- Device	: xc2vp50-7-ff1152
-- Input file	: memphy.ngc
-- Output file	: memphy_synthesis.vhd
-- # of Entities	: 1
-- Design Name	: memphy
-- Xilinx	: C:/Xilinx
--             
-- Purpose:    
--     This VHDL netlist is a verification model and uses simulation 
--     primitives which may not represent the true implementation of the 
--     device, however the netlist is functionally correct and should not 
--     be modified. This file cannot be synthesized and should only be used 
--     with supported simulation tools.
--             
-- Reference:  
--     Development System Reference Guide, Chapter 23
--     Synthesis and Verification Design Guide, Chapter 6
--             
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

entity memphy is
  port (
    mem_read_enable : in STD_LOGIC := 'X'; 
    in_write_strobe : in STD_LOGIC := 'X'; 
    in_reset_n : in STD_LOGIC := 'X'; 
    in_user_clk : in STD_LOGIC := 'X'; 
    w_n_1 : out STD_LOGIC; 
    w_n_2 : out STD_LOGIC; 
    w_n_3 : out STD_LOGIC; 
    w_n_4 : out STD_LOGIC; 
    r_n_1 : out STD_LOGIC; 
    r_n_2 : out STD_LOGIC; 
    r_n_3 : out STD_LOGIC; 
    r_n_4 : out STD_LOGIC; 
    in_write_data : in STD_LOGIC_VECTOR ( 63 downto 0 ); 
    in_write_index : in STD_LOGIC_VECTOR ( 25 downto 0 ); 
    dr_1 : in STD_LOGIC_VECTOR ( 71 downto 0 ); 
    dr_2 : in STD_LOGIC_VECTOR ( 71 downto 0 ); 
    dr_3 : in STD_LOGIC_VECTOR ( 71 downto 0 ); 
    dr_4 : in STD_LOGIC_VECTOR ( 71 downto 0 ); 
    in_index : in STD_LOGIC_VECTOR ( 25 downto 0 ); 
    dw_1 : out STD_LOGIC_VECTOR ( 71 downto 0 ); 
    dw_2 : out STD_LOGIC_VECTOR ( 71 downto 0 ); 
    dw_3 : out STD_LOGIC_VECTOR ( 71 downto 0 ); 
    dw_4 : out STD_LOGIC_VECTOR ( 71 downto 0 ); 
    aw_1 : out STD_LOGIC_VECTOR ( 19 downto 0 ); 
    aw_2 : out STD_LOGIC_VECTOR ( 19 downto 0 ); 
    aw_3 : out STD_LOGIC_VECTOR ( 19 downto 0 ); 
    aw_4 : out STD_LOGIC_VECTOR ( 19 downto 0 ); 
    ar_1 : out STD_LOGIC_VECTOR ( 19 downto 0 ); 
    ar_2 : out STD_LOGIC_VECTOR ( 19 downto 0 ); 
    ar_3 : out STD_LOGIC_VECTOR ( 19 downto 0 ); 
    ar_4 : out STD_LOGIC_VECTOR ( 19 downto 0 ); 
    bw_n_1 : out STD_LOGIC_VECTOR ( 7 downto 0 ); 
    bw_n_2 : out STD_LOGIC_VECTOR ( 7 downto 0 ); 
    bw_n_3 : out STD_LOGIC_VECTOR ( 7 downto 0 ); 
    bw_n_4 : out STD_LOGIC_VECTOR ( 7 downto 0 ); 
    out_data : out STD_LOGIC_VECTOR ( 2 downto 0 ) 
  );
end memphy;

architecture Structure of memphy is
  signal NlwRenamedSignal_r_n_4 : STD_LOGIC; 
  signal Q_n0100 : STD_LOGIC; 
  signal Q_n0101 : STD_LOGIC; 
  signal Q_n0102 : STD_LOGIC; 
  signal Q_n0103 : STD_LOGIC; 
  signal Q_n0104 : STD_LOGIC; 
  signal Q_n0105 : STD_LOGIC; 
  signal Q_n0110 : STD_LOGIC; 
  signal Q_n0106 : STD_LOGIC; 
  signal Q_n0111 : STD_LOGIC; 
  signal Q_n0107 : STD_LOGIC; 
  signal Q_n0112 : STD_LOGIC; 
  signal Q_n0108 : STD_LOGIC; 
  signal Q_n0113 : STD_LOGIC; 
  signal Q_n0109 : STD_LOGIC; 
  signal Q_n0114 : STD_LOGIC; 
  signal Q_n0070 : STD_LOGIC; 
  signal Q_n0115 : STD_LOGIC; 
  signal Q_n0120 : STD_LOGIC; 
  signal Q_n0071 : STD_LOGIC; 
  signal Q_n0116 : STD_LOGIC; 
  signal Q_n0121 : STD_LOGIC; 
  signal Q_n0072 : STD_LOGIC; 
  signal Q_n0117 : STD_LOGIC; 
  signal Q_n0122 : STD_LOGIC; 
  signal Q_n0068 : STD_LOGIC; 
  signal Q_n0073 : STD_LOGIC; 
  signal Q_n0118 : STD_LOGIC; 
  signal Q_n0123 : STD_LOGIC; 
  signal Q_n0069 : STD_LOGIC; 
  signal Q_n0074 : STD_LOGIC; 
  signal Q_n0119 : STD_LOGIC; 
  signal Q_n0124 : STD_LOGIC; 
  signal Q_n0075 : STD_LOGIC; 
  signal Q_n0080 : STD_LOGIC; 
  signal Q_n0125 : STD_LOGIC; 
  signal Q_n0130 : STD_LOGIC; 
  signal Q_n0076 : STD_LOGIC; 
  signal Q_n0081 : STD_LOGIC; 
  signal Q_n0126 : STD_LOGIC; 
  signal Q_n0077 : STD_LOGIC; 
  signal Q_n0082 : STD_LOGIC; 
  signal Q_n0127 : STD_LOGIC; 
  signal Q_n0132 : STD_LOGIC; 
  signal Q_n0078 : STD_LOGIC; 
  signal Q_n0083 : STD_LOGIC; 
  signal Q_n0128 : STD_LOGIC; 
  signal Q_n0133 : STD_LOGIC; 
  signal Q_n0079 : STD_LOGIC; 
  signal Q_n0084 : STD_LOGIC; 
  signal Q_n0129 : STD_LOGIC; 
  signal Q_n0085 : STD_LOGIC; 
  signal Q_n0090 : STD_LOGIC; 
  signal Q_n0135 : STD_LOGIC; 
  signal Q_n0086 : STD_LOGIC; 
  signal Q_n0091 : STD_LOGIC; 
  signal Q_n0136 : STD_LOGIC; 
  signal dw_1_12_N0 : STD_LOGIC; 
  signal Q_n0087 : STD_LOGIC; 
  signal Q_n0092 : STD_LOGIC; 
  signal Q_n0093 : STD_LOGIC; 
  signal Q_n0089 : STD_LOGIC; 
  signal Q_n0094 : STD_LOGIC; 
  signal Q_n0095 : STD_LOGIC; 
  signal Q_n0096 : STD_LOGIC; 
  signal Q_n0097 : STD_LOGIC; 
  signal Q_n0098 : STD_LOGIC; 
  signal Q_n0099 : STD_LOGIC; 
  signal N0 : STD_LOGIC; 
  signal N1 : STD_LOGIC; 
  signal N2 : STD_LOGIC; 
  signal N3 : STD_LOGIC; 
  signal N4 : STD_LOGIC; 
  signal N5 : STD_LOGIC; 
  signal N6 : STD_LOGIC; 
  signal N7 : STD_LOGIC; 
  signal N8 : STD_LOGIC; 
  signal N9 : STD_LOGIC; 
  signal N10 : STD_LOGIC; 
  signal N11 : STD_LOGIC; 
  signal N140 : STD_LOGIC; 
  signal N141 : STD_LOGIC; 
  signal N142 : STD_LOGIC; 
  signal N143 : STD_LOGIC; 
  signal N144 : STD_LOGIC; 
  signal N145 : STD_LOGIC; 
  signal read_fsm_0 : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal Q_n0134 : STD_LOGIC_VECTOR ( 19 downto 0 ); 
  signal read_fsm_0_n0000 : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal Q_n0088 : STD_LOGIC_VECTOR ( 19 downto 0 ); 
  signal Q_n0131 : STD_LOGIC_VECTOR ( 2 downto 0 ); 
  signal NlwRenamedSignal_bw_n_4 : STD_LOGIC_VECTOR ( 0 downto 0 ); 
begin
  w_n_2 <= NlwRenamedSignal_r_n_4;
  w_n_3 <= NlwRenamedSignal_r_n_4;
  w_n_4 <= NlwRenamedSignal_r_n_4;
  r_n_2 <= NlwRenamedSignal_r_n_4;
  r_n_3 <= NlwRenamedSignal_r_n_4;
  r_n_4 <= NlwRenamedSignal_r_n_4;
  dw_1(71) <= NlwRenamedSignal_bw_n_4(0);
  dw_1(62) <= NlwRenamedSignal_bw_n_4(0);
  dw_1(53) <= NlwRenamedSignal_bw_n_4(0);
  dw_1(44) <= NlwRenamedSignal_bw_n_4(0);
  dw_1(35) <= NlwRenamedSignal_bw_n_4(0);
  dw_1(26) <= NlwRenamedSignal_bw_n_4(0);
  dw_1(17) <= NlwRenamedSignal_bw_n_4(0);
  dw_1(8) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(71) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(70) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(69) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(68) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(67) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(66) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(65) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(64) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(63) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(62) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(61) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(60) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(59) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(58) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(57) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(56) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(55) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(54) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(53) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(52) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(51) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(50) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(49) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(48) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(47) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(46) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(45) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(44) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(43) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(42) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(41) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(40) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(39) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(38) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(37) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(36) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(35) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(34) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(33) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(32) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(31) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(30) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(29) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(28) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(27) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(26) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(25) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(24) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(23) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(22) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(21) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(20) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(19) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(18) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(17) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(16) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(15) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(14) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(13) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(12) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(11) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(10) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(9) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(8) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(7) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(6) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(5) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(4) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(3) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(2) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(1) <= NlwRenamedSignal_bw_n_4(0);
  dw_2(0) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(71) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(70) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(69) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(68) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(67) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(66) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(65) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(64) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(63) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(62) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(61) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(60) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(59) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(58) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(57) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(56) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(55) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(54) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(53) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(52) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(51) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(50) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(49) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(48) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(47) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(46) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(45) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(44) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(43) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(42) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(41) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(40) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(39) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(38) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(37) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(36) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(35) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(34) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(33) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(32) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(31) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(30) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(29) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(28) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(27) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(26) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(25) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(24) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(23) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(22) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(21) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(20) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(19) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(18) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(17) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(16) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(15) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(14) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(13) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(12) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(11) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(10) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(9) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(8) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(7) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(6) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(5) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(4) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(3) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(2) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(1) <= NlwRenamedSignal_bw_n_4(0);
  dw_3(0) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(71) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(70) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(69) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(68) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(67) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(66) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(65) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(64) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(63) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(62) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(61) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(60) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(59) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(58) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(57) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(56) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(55) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(54) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(53) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(52) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(51) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(50) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(49) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(48) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(47) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(46) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(45) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(44) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(43) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(42) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(41) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(40) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(39) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(38) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(37) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(36) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(35) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(34) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(33) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(32) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(31) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(30) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(29) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(28) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(27) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(26) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(25) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(24) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(23) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(22) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(21) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(20) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(19) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(18) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(17) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(16) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(15) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(14) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(13) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(12) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(11) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(10) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(9) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(8) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(7) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(6) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(5) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(4) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(3) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(2) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(1) <= NlwRenamedSignal_bw_n_4(0);
  dw_4(0) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(19) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(18) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(17) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(16) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(15) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(14) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(13) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(12) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(11) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(10) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(9) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(8) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(7) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(6) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(5) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(4) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(3) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(2) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(1) <= NlwRenamedSignal_bw_n_4(0);
  aw_2(0) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(19) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(18) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(17) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(16) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(15) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(14) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(13) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(12) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(11) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(10) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(9) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(8) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(7) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(6) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(5) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(4) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(3) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(2) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(1) <= NlwRenamedSignal_bw_n_4(0);
  aw_3(0) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(19) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(18) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(17) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(16) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(15) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(14) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(13) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(12) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(11) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(10) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(9) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(8) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(7) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(6) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(5) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(4) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(3) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(2) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(1) <= NlwRenamedSignal_bw_n_4(0);
  aw_4(0) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(19) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(18) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(17) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(16) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(15) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(14) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(13) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(12) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(11) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(10) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(9) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(8) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(7) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(6) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(5) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(4) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(3) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(2) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(1) <= NlwRenamedSignal_bw_n_4(0);
  ar_2(0) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(19) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(18) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(17) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(16) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(15) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(14) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(13) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(12) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(11) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(10) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(9) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(8) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(7) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(6) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(5) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(4) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(3) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(2) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(1) <= NlwRenamedSignal_bw_n_4(0);
  ar_3(0) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(19) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(18) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(17) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(16) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(15) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(14) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(13) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(12) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(11) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(10) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(9) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(8) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(7) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(6) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(5) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(4) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(3) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(2) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(1) <= NlwRenamedSignal_bw_n_4(0);
  ar_4(0) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_1(7) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_1(6) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_1(5) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_1(4) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_1(3) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_1(2) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_1(1) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_1(0) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_2(7) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_2(6) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_2(5) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_2(4) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_2(3) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_2(2) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_2(1) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_2(0) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_3(7) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_3(6) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_3(5) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_3(4) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_3(3) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_3(2) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_3(1) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_3(0) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_4(7) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_4(6) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_4(5) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_4(4) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_4(3) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_4(2) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_4(1) <= NlwRenamedSignal_bw_n_4(0);
  bw_n_4(0) <= NlwRenamedSignal_bw_n_4(0);
  XST_GND : GND
    port map (
      G => NlwRenamedSignal_bw_n_4(0)
    );
  read_fsm_0_Madd_n0000_n00061_INV_0 : INV
    port map (
      I => read_fsm_0(0),
      O => read_fsm_0_n0000(0)
    );
  read_fsm_0_Madd_n0000_Mxor_Result_1_Result1 : LUT2_L
    generic map(
      INIT => X"6"
    )
    port map (
      I0 => read_fsm_0(0),
      I1 => read_fsm_0(1),
      LO => read_fsm_0_n0000(1)
    );
  dw_1_12_N01_INV_0 : INV
    port map (
      I => in_reset_n,
      O => dw_1_12_N0
    );
  Q_n00681 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(12),
      I1 => in_write_strobe,
      O => Q_n0068
    );
  Q_n00691 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(13),
      I1 => in_write_strobe,
      O => Q_n0069
    );
  Q_n00701 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(14),
      I1 => in_write_strobe,
      O => Q_n0070
    );
  Q_n00711 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(18),
      I1 => in_write_strobe,
      O => Q_n0071
    );
  ar_1_0 : FDC
    port map (
      D => Q_n0088(0),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(0)
    );
  read_fsm_0_2 : FDCE
    port map (
      D => read_fsm_0_n0000(2),
      CE => mem_read_enable,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => read_fsm_0(2)
    );
  Q_n00811 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(28),
      I1 => in_write_strobe,
      O => Q_n0081
    );
  Q_n00821 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(24),
      I1 => in_write_strobe,
      O => Q_n0082
    );
  read_fsm_0_0 : FDCE
    port map (
      D => read_fsm_0_n0000(0),
      CE => mem_read_enable,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => read_fsm_0(0)
    );
  read_fsm_0_1 : FDCE
    port map (
      D => read_fsm_0_n0000(1),
      CE => mem_read_enable,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => read_fsm_0(1)
    );
  Q_n0131_2_51 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => dr_1(38),
      I1 => dr_1(2),
      I2 => read_fsm_0(2),
      O => N11
    );
  ar_1_8 : FDC
    port map (
      D => Q_n0088(8),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(8)
    );
  Q_n00721 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(15),
      I1 => in_write_strobe,
      O => Q_n0072
    );
  Q_n00731 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(19),
      I1 => in_write_strobe,
      O => Q_n0073
    );
  Q_n00741 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(20),
      I1 => in_write_strobe,
      O => Q_n0074
    );
  Q_n00751 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(16),
      I1 => in_write_strobe,
      O => Q_n0075
    );
  read_fsm_0_Madd_n0000_Mxor_Result_2_Result1 : LUT3_L
    generic map(
      INIT => X"78"
    )
    port map (
      I0 => read_fsm_0(0),
      I1 => read_fsm_0(1),
      I2 => read_fsm_0(2),
      LO => read_fsm_0_n0000(2)
    );
  Q_n00831 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(29),
      I1 => in_write_strobe,
      O => Q_n0083
    );
  Q_n00841 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(25),
      I1 => in_write_strobe,
      O => Q_n0084
    );
  Q_n00851 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(30),
      I1 => in_write_strobe,
      O => Q_n0085
    );
  Q_n00861 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(26),
      I1 => in_write_strobe,
      O => Q_n0086
    );
  Q_n00871 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(31),
      I1 => in_write_strobe,
      O => Q_n0087
    );
  Q_n0088_19_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(22),
      I1 => mem_read_enable,
      O => Q_n0088(19)
    );
  Q_n0088_18_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(21),
      I1 => mem_read_enable,
      O => Q_n0088(18)
    );
  Q_n0088_17_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(20),
      I1 => mem_read_enable,
      O => Q_n0088(17)
    );
  Q_n0088_16_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(19),
      I1 => mem_read_enable,
      O => Q_n0088(16)
    );
  Q_n0088_15_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(18),
      I1 => mem_read_enable,
      O => Q_n0088(15)
    );
  Q_n0088_14_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(17),
      I1 => mem_read_enable,
      O => Q_n0088(14)
    );
  Q_n0088_13_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(16),
      I1 => mem_read_enable,
      O => Q_n0088(13)
    );
  Q_n0088_12_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(15),
      I1 => mem_read_enable,
      O => Q_n0088(12)
    );
  Q_n0088_11_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(14),
      I1 => mem_read_enable,
      O => Q_n0088(11)
    );
  Q_n0088_10_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(13),
      I1 => mem_read_enable,
      O => Q_n0088(10)
    );
  Q_n0088_9_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(12),
      I1 => mem_read_enable,
      O => Q_n0088(9)
    );
  Q_n0088_8_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(11),
      I1 => mem_read_enable,
      O => Q_n0088(8)
    );
  Q_n0088_7_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(10),
      I1 => mem_read_enable,
      O => Q_n0088(7)
    );
  Q_n0088_6_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(9),
      I1 => mem_read_enable,
      O => Q_n0088(6)
    );
  Q_n0131_2_41 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => dr_1(56),
      I1 => dr_1(20),
      I2 => read_fsm_0(2),
      O => N10
    );
  Q_n0131_2_31 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => dr_1(47),
      I1 => dr_1(11),
      I2 => read_fsm_0(2),
      O => N9
    );
  aw_1_18 : FDC
    port map (
      D => Q_n0134(18),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(18)
    );
  Q_n0088_5_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(8),
      I1 => mem_read_enable,
      O => Q_n0088(5)
    );
  Q_n0088_4_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(7),
      I1 => mem_read_enable,
      O => Q_n0088(4)
    );
  Q_n0088_3_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(6),
      I1 => mem_read_enable,
      O => Q_n0088(3)
    );
  Q_n0088_2_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(5),
      I1 => mem_read_enable,
      O => Q_n0088(2)
    );
  Q_n0088_1_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(4),
      I1 => mem_read_enable,
      O => Q_n0088(1)
    );
  Q_n0088_0_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_index(3),
      I1 => mem_read_enable,
      O => Q_n0088(0)
    );
  Q_n00891 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(36),
      I1 => in_write_strobe,
      O => Q_n0089
    );
  Q_n00901 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(32),
      I1 => in_write_strobe,
      O => Q_n0090
    );
  Q_n00911 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(37),
      I1 => in_write_strobe,
      O => Q_n0091
    );
  Q_n00921 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(33),
      I1 => in_write_strobe,
      O => Q_n0092
    );
  Q_n00931 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(38),
      I1 => in_write_strobe,
      O => Q_n0093
    );
  Q_n00941 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(34),
      I1 => in_write_strobe,
      O => Q_n0094
    );
  Q_n00951 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(39),
      I1 => in_write_strobe,
      O => Q_n0095
    );
  Q_n00961 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(35),
      I1 => in_write_strobe,
      O => Q_n0096
    );
  Q_n00971 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(40),
      I1 => in_write_strobe,
      O => Q_n0097
    );
  Q_n00981 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(45),
      I1 => in_write_strobe,
      O => Q_n0098
    );
  Q_n00991 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(41),
      I1 => in_write_strobe,
      O => Q_n0099
    );
  Q_n01001 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(46),
      I1 => in_write_strobe,
      O => Q_n0100
    );
  Q_n01011 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(42),
      I1 => in_write_strobe,
      O => Q_n0101
    );
  Q_n01021 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(47),
      I1 => in_write_strobe,
      O => Q_n0102
    );
  Q_n01031 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(43),
      I1 => in_write_strobe,
      O => Q_n0103
    );
  Q_n01041 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(44),
      I1 => in_write_strobe,
      O => Q_n0104
    );
  Q_n01051 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(48),
      I1 => in_write_strobe,
      O => Q_n0105
    );
  Q_n01061 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(49),
      I1 => in_write_strobe,
      O => Q_n0106
    );
  Q_n01071 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(54),
      I1 => in_write_strobe,
      O => Q_n0107
    );
  Q_n01081 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(50),
      I1 => in_write_strobe,
      O => Q_n0108
    );
  Q_n01091 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(55),
      I1 => in_write_strobe,
      O => Q_n0109
    );
  Q_n01101 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(51),
      I1 => in_write_strobe,
      O => Q_n0110
    );
  Q_n01111_INV_0 : INV
    port map (
      I => mem_read_enable,
      O => Q_n0111
    );
  Q_n01121 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(52),
      I1 => in_write_strobe,
      O => Q_n0112
    );
  Q_n01131 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(56),
      I1 => in_write_strobe,
      O => Q_n0113
    );
  Q_n01141 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(0),
      I1 => in_write_strobe,
      O => Q_n0114
    );
  Q_n01151 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(53),
      I1 => in_write_strobe,
      O => Q_n0115
    );
  Q_n01161 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(57),
      I1 => in_write_strobe,
      O => Q_n0116
    );
  Q_n01171 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(1),
      I1 => in_write_strobe,
      O => Q_n0117
    );
  Q_n01181 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(58),
      I1 => in_write_strobe,
      O => Q_n0118
    );
  Q_n01191 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(63),
      I1 => in_write_strobe,
      O => Q_n0119
    );
  Q_n01201 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(2),
      I1 => in_write_strobe,
      O => Q_n0120
    );
  Q_n01211 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(59),
      I1 => in_write_strobe,
      O => Q_n0121
    );
  Q_n01221 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(3),
      I1 => in_write_strobe,
      O => Q_n0122
    );
  Q_n01231 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(60),
      I1 => in_write_strobe,
      O => Q_n0123
    );
  Q_n01241 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(4),
      I1 => in_write_strobe,
      O => Q_n0124
    );
  Q_n01251 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(61),
      I1 => in_write_strobe,
      O => Q_n0125
    );
  Q_n01261 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(5),
      I1 => in_write_strobe,
      O => Q_n0126
    );
  Q_n01271 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(62),
      I1 => in_write_strobe,
      O => Q_n0127
    );
  Q_n01281 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(6),
      I1 => in_write_strobe,
      O => Q_n0128
    );
  Q_n01291_INV_0 : INV
    port map (
      I => in_write_strobe,
      O => Q_n0129
    );
  Q_n01301 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(7),
      I1 => in_write_strobe,
      O => Q_n0130
    );
  Q_n01321 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(8),
      I1 => in_write_strobe,
      O => Q_n0132
    );
  Q_n01331 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(9),
      I1 => in_write_strobe,
      O => Q_n0133
    );
  Q_n0134_19_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(22),
      I1 => in_write_strobe,
      O => Q_n0134(19)
    );
  Q_n0134_18_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(21),
      I1 => in_write_strobe,
      O => Q_n0134(18)
    );
  Q_n0134_17_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(20),
      I1 => in_write_strobe,
      O => Q_n0134(17)
    );
  Q_n0134_16_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(19),
      I1 => in_write_strobe,
      O => Q_n0134(16)
    );
  Q_n0134_15_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(18),
      I1 => in_write_strobe,
      O => Q_n0134(15)
    );
  Q_n0134_14_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(17),
      I1 => in_write_strobe,
      O => Q_n0134(14)
    );
  Q_n0134_13_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(16),
      I1 => in_write_strobe,
      O => Q_n0134(13)
    );
  Q_n0134_12_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(15),
      I1 => in_write_strobe,
      O => Q_n0134(12)
    );
  Q_n0134_11_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(14),
      I1 => in_write_strobe,
      O => Q_n0134(11)
    );
  Q_n0134_10_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(13),
      I1 => in_write_strobe,
      O => Q_n0134(10)
    );
  Q_n0134_9_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(12),
      I1 => in_write_strobe,
      O => Q_n0134(9)
    );
  Q_n0134_8_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(11),
      I1 => in_write_strobe,
      O => Q_n0134(8)
    );
  Q_n0134_7_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(10),
      I1 => in_write_strobe,
      O => Q_n0134(7)
    );
  Q_n0134_6_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(9),
      I1 => in_write_strobe,
      O => Q_n0134(6)
    );
  Q_n0134_5_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(8),
      I1 => in_write_strobe,
      O => Q_n0134(5)
    );
  Q_n0134_4_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(7),
      I1 => in_write_strobe,
      O => Q_n0134(4)
    );
  Q_n0134_3_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(6),
      I1 => in_write_strobe,
      O => Q_n0134(3)
    );
  dw_1_13 : FDC
    port map (
      D => Q_n0068,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(13)
    );
  dw_1_14 : FDC
    port map (
      D => Q_n0069,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(14)
    );
  dw_1_15 : FDC
    port map (
      D => Q_n0070,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(15)
    );
  dw_1_20 : FDC
    port map (
      D => Q_n0071,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(20)
    );
  dw_1_16 : FDC
    port map (
      D => Q_n0072,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(16)
    );
  dw_1_21 : FDC
    port map (
      D => Q_n0073,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(21)
    );
  dw_1_22 : FDC
    port map (
      D => Q_n0074,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(22)
    );
  dw_1_18 : FDC
    port map (
      D => Q_n0075,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(18)
    );
  dw_1_23 : FDC
    port map (
      D => Q_n0076,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(23)
    );
  dw_1_19 : FDC
    port map (
      D => Q_n0077,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(19)
    );
  dw_1_24 : FDC
    port map (
      D => Q_n0078,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(24)
    );
  dw_1_25 : FDC
    port map (
      D => Q_n0079,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(25)
    );
  dw_1_30 : FDC
    port map (
      D => Q_n0080,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(30)
    );
  dw_1_31 : FDC
    port map (
      D => Q_n0081,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(31)
    );
  Q_n0134_2_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(5),
      I1 => in_write_strobe,
      O => Q_n0134(2)
    );
  dw_1_27 : FDC
    port map (
      D => Q_n0082,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(27)
    );
  dw_1_32 : FDC
    port map (
      D => Q_n0083,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(32)
    );
  dw_1_28 : FDC
    port map (
      D => Q_n0084,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(28)
    );
  dw_1_33 : FDC
    port map (
      D => Q_n0085,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(33)
    );
  dw_1_29 : FDC
    port map (
      D => Q_n0086,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(29)
    );
  dw_1_34 : FDC
    port map (
      D => Q_n0087,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(34)
    );
  ar_1_19 : FDC
    port map (
      D => Q_n0088(19),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(19)
    );
  dw_1_40 : FDC
    port map (
      D => Q_n0089,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(40)
    );
  dw_1_36 : FDC
    port map (
      D => Q_n0090,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(36)
    );
  dw_1_41 : FDC
    port map (
      D => Q_n0091,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(41)
    );
  dw_1_37 : FDC
    port map (
      D => Q_n0092,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(37)
    );
  dw_1_42 : FDC
    port map (
      D => Q_n0093,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(42)
    );
  dw_1_38 : FDC
    port map (
      D => Q_n0094,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(38)
    );
  dw_1_43 : FDC
    port map (
      D => Q_n0095,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(43)
    );
  dw_1_39 : FDC
    port map (
      D => Q_n0096,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(39)
    );
  dw_1_45 : FDC
    port map (
      D => Q_n0097,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(45)
    );
  dw_1_50 : FDC
    port map (
      D => Q_n0098,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(50)
    );
  dw_1_46 : FDC
    port map (
      D => Q_n0099,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(46)
    );
  dw_1_51 : FDC
    port map (
      D => Q_n0100,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(51)
    );
  dw_1_47 : FDC
    port map (
      D => Q_n0101,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(47)
    );
  dw_1_52 : FDC
    port map (
      D => Q_n0102,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(52)
    );
  dw_1_48 : FDC
    port map (
      D => Q_n0103,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(48)
    );
  dw_1_49 : FDC
    port map (
      D => Q_n0104,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(49)
    );
  dw_1_54 : FDC
    port map (
      D => Q_n0105,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(54)
    );
  dw_1_55 : FDC
    port map (
      D => Q_n0106,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(55)
    );
  dw_1_60 : FDC
    port map (
      D => Q_n0107,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(60)
    );
  dw_1_56 : FDC
    port map (
      D => Q_n0108,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(56)
    );
  dw_1_61 : FDC
    port map (
      D => Q_n0109,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(61)
    );
  dw_1_57 : FDC
    port map (
      D => Q_n0110,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(57)
    );
  r_n_1_0 : FDP
    port map (
      D => Q_n0111,
      PRE => dw_1_12_N0,
      C => in_user_clk,
      Q => r_n_1
    );
  dw_1_58 : FDC
    port map (
      D => Q_n0112,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(58)
    );
  dw_1_63 : FDC
    port map (
      D => Q_n0113,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(63)
    );
  dw_1_0 : FDC
    port map (
      D => Q_n0114,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(0)
    );
  dw_1_59 : FDC
    port map (
      D => Q_n0115,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(59)
    );
  dw_1_64 : FDC
    port map (
      D => Q_n0116,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(64)
    );
  dw_1_1 : FDC
    port map (
      D => Q_n0117,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(1)
    );
  dw_1_65 : FDC
    port map (
      D => Q_n0118,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(65)
    );
  dw_1_70 : FDC
    port map (
      D => Q_n0119,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(70)
    );
  dw_1_2 : FDC
    port map (
      D => Q_n0120,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(2)
    );
  dw_1_66 : FDC
    port map (
      D => Q_n0121,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(66)
    );
  dw_1_3 : FDC
    port map (
      D => Q_n0122,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(3)
    );
  dw_1_67 : FDC
    port map (
      D => Q_n0123,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(67)
    );
  dw_1_4 : FDC
    port map (
      D => Q_n0124,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(4)
    );
  dw_1_68 : FDC
    port map (
      D => Q_n0125,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(68)
    );
  dw_1_5 : FDC
    port map (
      D => Q_n0126,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(5)
    );
  dw_1_69 : FDC
    port map (
      D => Q_n0127,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(69)
    );
  dw_1_6 : FDC
    port map (
      D => Q_n0128,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(6)
    );
  w_n_1_1 : FDP
    port map (
      D => Q_n0129,
      PRE => dw_1_12_N0,
      C => in_user_clk,
      Q => w_n_1
    );
  dw_1_7 : FDC
    port map (
      D => Q_n0130,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(7)
    );
  out_data_2 : FDP
    port map (
      D => Q_n0131(2),
      PRE => dw_1_12_N0,
      C => in_user_clk,
      Q => out_data(2)
    );
  dw_1_9 : FDC
    port map (
      D => Q_n0132,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(9)
    );
  dw_1_10 : FDC
    port map (
      D => Q_n0133,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(10)
    );
  aw_1_19 : FDC
    port map (
      D => Q_n0134(19),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(19)
    );
  dw_1_11 : FDC
    port map (
      D => Q_n0135,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(11)
    );
  dw_1_12 : FDC
    port map (
      D => Q_n0136,
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => dw_1(12)
    );
  Q_n0134_1_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(4),
      I1 => in_write_strobe,
      O => Q_n0134(1)
    );
  Q_n0134_0_1 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_index(3),
      I1 => in_write_strobe,
      O => Q_n0134(0)
    );
  Q_n01351 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(10),
      I1 => in_write_strobe,
      O => Q_n0135
    );
  Q_n01361 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(11),
      I1 => in_write_strobe,
      O => Q_n0136
    );
  Q_n00761 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(21),
      I1 => in_write_strobe,
      O => Q_n0076
    );
  Q_n00771 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(17),
      I1 => in_write_strobe,
      O => Q_n0077
    );
  Q_n00781 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(22),
      I1 => in_write_strobe,
      O => Q_n0078
    );
  Q_n00791 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(23),
      I1 => in_write_strobe,
      O => Q_n0079
    );
  XST_VCC : VCC
    port map (
      P => NlwRenamedSignal_r_n_4
    );
  Q_n00801 : LUT2
    generic map(
      INIT => X"8"
    )
    port map (
      I0 => in_write_data(27),
      I1 => in_write_strobe,
      O => Q_n0080
    );
  ar_1_4 : FDC
    port map (
      D => Q_n0088(4),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(4)
    );
  ar_1_5 : FDC
    port map (
      D => Q_n0088(5),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(5)
    );
  ar_1_7 : FDC
    port map (
      D => Q_n0088(7),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(7)
    );
  ar_1_9 : FDC
    port map (
      D => Q_n0088(9),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(9)
    );
  ar_1_10 : FDC
    port map (
      D => Q_n0088(10),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(10)
    );
  ar_1_11 : FDC
    port map (
      D => Q_n0088(11),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(11)
    );
  ar_1_12 : FDC
    port map (
      D => Q_n0088(12),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(12)
    );
  ar_1_13 : FDC
    port map (
      D => Q_n0088(13),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(13)
    );
  ar_1_14 : FDC
    port map (
      D => Q_n0088(14),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(14)
    );
  ar_1_15 : FDC
    port map (
      D => Q_n0088(15),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(15)
    );
  ar_1_16 : FDC
    port map (
      D => Q_n0088(16),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(16)
    );
  ar_1_17 : FDC
    port map (
      D => Q_n0088(17),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(17)
    );
  ar_1_18 : FDC
    port map (
      D => Q_n0088(18),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(18)
    );
  aw_1_0 : FDC
    port map (
      D => Q_n0134(0),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(0)
    );
  ar_1_6 : FDC
    port map (
      D => Q_n0088(6),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(6)
    );
  ar_1_1 : FDC
    port map (
      D => Q_n0088(1),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(1)
    );
  out_data_0 : FDP
    port map (
      D => Q_n0131(0),
      PRE => dw_1_12_N0,
      C => in_user_clk,
      Q => out_data(0)
    );
  out_data_1 : FDP
    port map (
      D => Q_n0131(1),
      PRE => dw_1_12_N0,
      C => in_user_clk,
      Q => out_data(1)
    );
  ar_1_2 : FDC
    port map (
      D => Q_n0088(2),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(2)
    );
  ar_1_3 : FDC
    port map (
      D => Q_n0088(3),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => ar_1(3)
    );
  aw_1_1 : FDC
    port map (
      D => Q_n0134(1),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(1)
    );
  aw_1_2 : FDC
    port map (
      D => Q_n0134(2),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(2)
    );
  aw_1_3 : FDC
    port map (
      D => Q_n0134(3),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(3)
    );
  aw_1_4 : FDC
    port map (
      D => Q_n0134(4),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(4)
    );
  aw_1_5 : FDC
    port map (
      D => Q_n0134(5),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(5)
    );
  aw_1_6 : FDC
    port map (
      D => Q_n0134(6),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(6)
    );
  aw_1_7 : FDC
    port map (
      D => Q_n0134(7),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(7)
    );
  aw_1_8 : FDC
    port map (
      D => Q_n0134(8),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(8)
    );
  aw_1_9 : FDC
    port map (
      D => Q_n0134(9),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(9)
    );
  aw_1_10 : FDC
    port map (
      D => Q_n0134(10),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(10)
    );
  aw_1_11 : FDC
    port map (
      D => Q_n0134(11),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(11)
    );
  aw_1_12 : FDC
    port map (
      D => Q_n0134(12),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(12)
    );
  aw_1_13 : FDC
    port map (
      D => Q_n0134(13),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(13)
    );
  aw_1_14 : FDC
    port map (
      D => Q_n0134(14),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(14)
    );
  aw_1_15 : FDC
    port map (
      D => Q_n0134(15),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(15)
    );
  aw_1_16 : FDC
    port map (
      D => Q_n0134(16),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(16)
    );
  aw_1_17 : FDC
    port map (
      D => Q_n0134(17),
      CLR => dw_1_12_N0,
      C => in_user_clk,
      Q => aw_1(17)
    );
  Q_n0131_2_1391_G : LUT4_L
    generic map(
      INIT => X"E4FF"
    )
    port map (
      I0 => read_fsm_0(0),
      I1 => N10,
      I2 => N8,
      I3 => mem_read_enable,
      LO => N141
    );
  Q_n0131_0_21 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => dr_1(63),
      I1 => dr_1(27),
      I2 => read_fsm_0(2),
      O => N0
    );
  Q_n0131_0_31 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => dr_1(45),
      I1 => dr_1(9),
      I2 => read_fsm_0(2),
      O => N1
    );
  Q_n0131_0_41 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => dr_1(54),
      I1 => dr_1(18),
      I2 => read_fsm_0(2),
      O => N2
    );
  Q_n0131_0_51 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => dr_1(36),
      I1 => dr_1(0),
      I2 => read_fsm_0(2),
      O => N3
    );
  Q_n0131_0_1391_G : LUT4_L
    generic map(
      INIT => X"E4FF"
    )
    port map (
      I0 => read_fsm_0(0),
      I1 => N2,
      I2 => N0,
      I3 => mem_read_enable,
      LO => N143
    );
  Q_n0131_1_21 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => dr_1(64),
      I1 => dr_1(28),
      I2 => read_fsm_0(2),
      O => N4
    );
  Q_n0131_1_31 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => dr_1(46),
      I1 => dr_1(10),
      I2 => read_fsm_0(2),
      O => N5
    );
  Q_n0131_1_41 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => dr_1(55),
      I1 => dr_1(19),
      I2 => read_fsm_0(2),
      O => N6
    );
  Q_n0131_1_51 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => dr_1(37),
      I1 => dr_1(1),
      I2 => read_fsm_0(2),
      O => N7
    );
  Q_n0131_2_21 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => dr_1(65),
      I1 => dr_1(29),
      I2 => read_fsm_0(2),
      O => N8
    );
  Q_n0131_1_1391_G : LUT4_L
    generic map(
      INIT => X"E4FF"
    )
    port map (
      I0 => read_fsm_0(0),
      I1 => N6,
      I2 => N4,
      I3 => mem_read_enable,
      LO => N145
    );
  Q_n0131_2_1391 : MUXF5
    port map (
      I0 => N140,
      I1 => N141,
      S => read_fsm_0(1),
      O => Q_n0131(2)
    );
  Q_n0131_2_1391_F : LUT4_L
    generic map(
      INIT => X"E4FF"
    )
    port map (
      I0 => read_fsm_0(0),
      I1 => N11,
      I2 => N9,
      I3 => mem_read_enable,
      LO => N140
    );
  Q_n0131_0_1391 : MUXF5
    port map (
      I0 => N142,
      I1 => N143,
      S => read_fsm_0(1),
      O => Q_n0131(0)
    );
  Q_n0131_0_1391_F : LUT4_L
    generic map(
      INIT => X"E4FF"
    )
    port map (
      I0 => read_fsm_0(0),
      I1 => N3,
      I2 => N1,
      I3 => mem_read_enable,
      LO => N142
    );
  Q_n0131_1_1391 : MUXF5
    port map (
      I0 => N144,
      I1 => N145,
      S => read_fsm_0(1),
      O => Q_n0131(1)
    );
  Q_n0131_1_1391_F : LUT4_L
    generic map(
      INIT => X"E4FF"
    )
    port map (
      I0 => read_fsm_0(0),
      I1 => N7,
      I2 => N5,
      I3 => mem_read_enable,
      LO => N144
    );

end Structure;

